SystemOrganization addCategory: #'Ma object serialization-API'!
SystemOrganization addCategory: #'Ma object serialization-Info'!
SystemOrganization addCategory: #'Ma object serialization-exceptions'!
SystemOrganization addCategory: #'Ma object serialization-private'!
SystemOrganization addCategory: #'Ma object serialization-support'!

!TranscriptStream class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:37'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ Transcript! !

!TranscriptStream methodsFor: '*ma object serialization' stamp: 'cmm 12/19/2002 23:13'!
maAsStorageObject
	"We don't even need to store the name of this global.  It's class
	gives it away."

	^String maEmpty! !

!TranscriptStream methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!TTFontDescription class methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:16'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"Materialize the DiskProxy which computes a reference to an appropriate object in this materializing system."

	| diskProxy |
	diskProxy _ aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!TTFontDescription methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:16'!
maAsStorageObject 
	^ DiskProxy 
		global: #TTFontDescription selector: #descriptionNamed:
		args: { self fullName }! !

!TTFontDescription methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:15'!
maUsesStandardStorage 
	^ false! !

!ScriptEditorMorph methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 14:35'!
maWantsPostMaterialization 
	^ true! !

!Metaclass class methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 23:40'!
maMaterializeFrom: aMaClassReferenceBuffer using: aMaObjectSerializer

	^ (Class
		maMaterializeFrom: aMaClassReferenceBuffer
		using: aMaObjectSerializer) class! !

!Metaclass methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 22:57'!
maInstancesRequireOwnBuffer

	^ true! !

!Metaclass methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 22:53'!
maSerializationClass

	^ Metaclass! !

!Metaclass methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!Project methodsFor: '*ma object serialization' stamp: 'cmm 2/22/2005 12:49'!
maTransientVariables
	"Don't store or traverse these variables when serializing me."
	^ super maTransientVariables, #('parentProject' 'nextProject' 'previousProject')! !

!Project methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 15:15'!
maWantsPostMaterialization 
	^ true! !

!Project methodsFor: '*ma object serialization' stamp: 'cmm 2/11/2005 09:53'!
maWantsPreSerialization
	^ true! !

!Object class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer
	^ true! !

!Object class methodsFor: '*ma object serialization' stamp: 'cmm 2/23/2005 14:54'!
maLoadVariableObjectFrom: aMaVariableObjectBuffer
	"This is the standard-case for building a skeleton of a variably-sized object."
	| skeleton |
	skeleton _ self basicNew: aMaVariableObjectBuffer objectInstSize - self instSize.
	1
		to: aMaVariableObjectBuffer objectInstSize
		do:
			[ : index |
			skeleton
				instVarAt: index
				put: (aMaVariableObjectBuffer maInstVarAt: index) ].
	^ skeleton! !

!Object class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:47'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This is the standard-case for building a skeleton of a variable-byte-sized object."
	^ aMaByteObjectBuffer asByteObject: self! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 4/10/2005 18:00'!
maEstablishPointerReferencesUsing: aMaObjectSerializer 
	"I am currently loaded with oids of the objects that I should be referencing.  Now that objects for these oids are, themselves, materialized, I can now replace my referernces to oids wtih references to the real objects."

	self maOriginalClass isPointers 
		ifFalse: 
			["don't need to do this."

			^self].
	1 to: self maInstSize
		do: 
			[:instVarIndex | 
			| oid |
			oid := self instVarAt: instVarIndex.
			oid ifNotNil: 
					["could be nil if different class def"

					"we shouldn't need to worry about transient vars here because they would have been stored as nil."

					self instVarAt: instVarIndex
						put: (aMaObjectSerializer objectWithOid: oid
								ifAbsent: [aMaObjectSerializer proxyFor: oid])]]! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 23:51'!
maRequiresOwnBuffer
	"Answers false if the receiver has a special oid to represent it, such as nil, true, false and other immutables do."

	^ self class maInstancesRequireOwnBuffer! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 4/10/2005 18:00'!
maSerializationClass
	"For WriteBarrier support."

	^self maOriginalClass! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 2/13/2005 21:54'!
maStreamVariablyInto: aMaVariableBuffer for: aMaObjectSerializer
	"Put the receivers instance variables (both named and indexed) into aMaVariableObjectBuffer."

	1
		to: self maInstSize
		do:
			[ : index |
			(self maIsTransient: index)
				ifFalse:
					[ aMaVariableBuffer
						maInstVarAt: index
						put: (aMaObjectSerializer oidFor: (self instVarAt: index)) ] ]! !

!UUID class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:47'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ self fromString: aMaByteObjectBuffer asString! !

!UUID methodsFor: '*ma object serialization' stamp: 'cmm 11/7/2004 23:33'!
maAsStorageObject

	^ self asString! !

!UUID methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:39'!
maUsesStandardStorage

	^ false! !

!Float class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!Float methodsFor: '*ma object serialization' stamp: 'cmm 8/8/2002 23:05'!
maOid

	^MaOidCalculator oidForFloat: self! !

!Color methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 13:12'!
maWantsPreSerialization 
	^ true! !

!ChangeSet class methodsFor: '*ma object serialization' stamp: 'cmm 2/10/2005 16:26'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"Materialize the association:  change set name -> the stream on which the change set was filed out.
	Signal the incoming chang-set notification and, if the user has written code to override the defaultAction, it will be filed in the name isn't already in use."

	| nameAndChangeSetAssociation changeSetName stream |
	nameAndChangeSetAssociation _ (aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray).
	changeSetName _ nameAndChangeSetAssociation key.
	stream _ nameAndChangeSetAssociation value.
	^ (MagmaIncomingChangeSetNotification signal: 'Is it ok to file-in ', changeSetName) == true "default to false if they return with a non-boolean."
		ifTrue:
			[ ChangeSorter
				newChangesFromStream: stream
				named: changeSetName ]
		ifFalse: [ ChangeSorter existingOrNewChangeSetNamed: changeSetName ]! !

!ChangeSet methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 21:43'!
maAsStorageObject
	"While we can store ChangeSets and their CompiledMethods directly, a logical representation (i.e., my fileOut) is probably better.  Therefore, we file out me to a stream and keep that along with my name.  My code will NOT be automatically filed-in on materialization."

	| stream |
	stream _ ReadWriteStream on: String new.
	self fileOutOn: stream.
	stream position: 0.
	^ self name -> stream! !

!ChangeSet methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 17:29'!
maUsesStandardStorage
	^ false! !

!ScreenController class methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:03'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This method exists to mirror the logic in my instance-side #objectForDataStream:.  We use a reference in this materializing image rather than the creating a new object."

	| diskProxy |
	diskProxy _ aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!ScreenController methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:01'!
maAsStorageObject
	"Like DataStream, just store a reference to me instead of me."

	^ DiskProxy
		global: #ScheduledControllers
		selector: #screenController args: #()! !

!ScreenController methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:00'!
maUsesStandardStorage 
	^ false! !

!SystemDictionary class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:37'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ Smalltalk! !

!SystemDictionary methodsFor: '*ma object serialization' stamp: 'cmm 12/19/2002 23:13'!
maAsStorageObject
	"We don't even need to store the name of the global.  It's class
	gives it away."

	^String maEmpty
! !

!SystemDictionary methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!DisplayScreen class methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 12:44'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This method exists to mirror the logic in my instance-side #objectForDataStream, whereby a DiskProxy is stored instead.  For Ma object serialization, this was done on my instance-side in #maAsStorageObject."

	| diskProxy |
	diskProxy _ aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!DisplayScreen methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 12:42'!
maAsStorageObject
	"Emulate the same behavior as #objectForDataStream:."

	^ DiskProxy global: #Display selector: #yourself args: #()! !

!DisplayScreen methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 12:42'!
maUsesStandardStorage 
	^ false! !

!Morph methodsFor: '*ma object serialization' stamp: 'cmm 2/22/2005 12:49'!
maTransientVariables

	^ owner == World  "If serializing a live Morph in the world."
		ifTrue: [ super maTransientVariables, #('owner') ]
		ifFalse: [ super maTransientVariables ]! !

!Morph methodsFor: '*ma object serialization' stamp: 'cmm 2/7/2005 21:55'!
maWantsPreSerialization
	^ true! !

!Dictionary class methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 12:35'!
maLoadVariableObjectFrom: aMaVariableObjectBuffer
	| skeleton |
	skeleton _ self new: aMaVariableObjectBuffer objectInstSize / 2. "key + value"
	1
		to: aMaVariableObjectBuffer objectInstSize
		by: 2
		do:
			[ :index |
			skeleton
				at: (aMaVariableObjectBuffer maInstVarAt: index)
				put: (aMaVariableObjectBuffer maInstVarAt: index + 1) ].
	^ skeleton! !

!Dictionary methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:55'!
maBufferInstSize

	^ self size * 2! !

!Dictionary methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 10:27'!
maEstablishPointerReferencesUsing: aMaObjectSerializer

	| transformer fullOfOidsCopy |
	self isEmpty ifTrue: [ ^ self ]. "performance"
	transformer _
		[ :object |
			(aMaObjectSerializer
				objectWithOid: object
				ifAbsent: [ aMaObjectSerializer proxyFor: object ]) ].
	fullOfOidsCopy _ self copy.
	self maRemoveAll.
	fullOfOidsCopy keysAndValuesDo:
		[ :eachKey :eachValue |
		self
			at: (transformer value: eachKey)
			put: (transformer value: eachValue) ]! !

!Dictionary methodsFor: '*ma object serialization' stamp: ''!
maIsHashedCollection

	^true
! !

!Dictionary methodsFor: '*ma object serialization' stamp: 'cmm 11/28/2004 16:20'!
maStreamVariablyInto: aMaVariableObjectBuffer for: aMaObjectSerializer
	"Put the receivers instance variables into aMaVariableObjectBuffer."

	| index |
	index _ 1.
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		[ : obj |
			aMaVariableObjectBuffer
				maInstVarAt: index
				put: (aMaObjectSerializer oidFor: obj).
			index _ index + 1 ]
				value: eachKey;
				value: eachValue ].
	"Now take care of additional named variables."
	3 "skip array and tally, they're taken care of logically, above."
		to: self maInstSize
		do:
			[ : namedIndex |
			aMaVariableObjectBuffer
				maInstVarAt: index + namedIndex
				put: (aMaObjectSerializer oidFor: (self instVarAt: namedIndex)) ]! !

MaSoftwareError subclass: #MaObjectSerializationSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

!Boolean class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!PasteUpMorph class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:52'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ World! !

!PasteUpMorph methodsFor: '*ma object serialization' stamp: 'cmm 2/22/2005 12:49'!
maTransientVariables

	^ super maTransientVariables, #('worldState')! !

!PasteUpMorph methodsFor: '*ma object serialization' stamp: 'cmm 2/11/2005 12:51'!
maWantsPreSerialization 
	^ true! !

!Bitmap class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:37'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ self decompressFromByteArray: aMaByteObjectBuffer asByteArray! !

!Bitmap methodsFor: '*ma object serialization' stamp: 'cmm 11/7/2004 22:54'!
maAsStorageObject

	^ self compressToByteArray! !

!Bitmap methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:00'!
maUsesStandardStorage

	^ false! !

MaWarning subclass: #MaObjectSerializationWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

!Symbol class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:47'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This is the standard-case for building a skeleton of a variable-byte-sized object."
	^ aMaByteObjectBuffer asString asSymbol! !

!Class class methodsFor: '*ma object serialization' stamp: 'cmm 10/28/2004 22:29'!
maMaterializeFrom: aMaClassReferenceBuffer using: aMaObjectSerializer

	^ (aMaObjectSerializer classIdManager 
		classDefinitionsForId: aMaClassReferenceBuffer representedClassId) last

		ensureClassUsing: aMaObjectSerializer! !

!Class methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 22:53'!
maSerializationClass

	^ Class! !

!Class methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

MaSecurityViolation subclass: #MaObjectSerializationSecurityViolation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

!CompiledMethod class methodsFor: '*ma object serialization' stamp: 'cmm 11/15/2004 15:21'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ (aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray) asCompiledMethod! !

!CompiledMethod methodsFor: '*ma object serialization' stamp: 'cmm 11/12/2004 10:54'!
maAsStorageObject

	^ MaCompiledMethodStorage newFor: self! !

!CompiledMethod methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!TTCFont methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 22:43'!
maWantsPreSerialization 
	^ true! !

!ViewerFlapTab methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 14:34'!
maWantsPostMaterialization 
	^ true! !

!LargePositiveInteger class methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 23:56'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ aMaByteObjectBuffer asByteObject: self! !

!LargePositiveInteger methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 23:19'!
maAsStorageObject

	| answer |
	answer _ ByteArray new: self digitLength.
	1 to: self digitLength do:
		[ : x |
		answer at: x put: (self digitAt: x) ].
	^ answer! !

!LargePositiveInteger methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:36'!
maUsesStandardStorage 
	^ false! !

!ContextPart methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!Behavior methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 15:27'!
maAllInstVarNamesAt: anInteger

	| x |
	x _ 0.
	self maAllInstVarNamesDo:
		[ : each | 
		x _ x + 1.
		x = anInteger ifTrue: [ ^ each ] ].
	self error: 'Index out of bounds:  ', anInteger printString! !

!SystemOrganizer class methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:14'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"A simpler, alternative way to store a direct global reference than using DiskProxy."

	^ SystemOrganization! !

!SystemOrganizer methodsFor: '*ma object serialization' stamp: 'cmm 2/17/2005 13:56'!
maAsStorageObject 
	^ String maEmpty! !

!SystemOrganizer methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:13'!
maUsesStandardStorage 
	^ false! !

!HandMorph class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:37'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ ActiveHand! !

!HandMorph methodsFor: '*ma object serialization' stamp: 'cmm 6/30/2004 13:58'!
maAsStorageObject
	"We don't yet support serialization of individual HandMorphs.  For now, we restore any HandMorph as a logical link to the ActiveHand."

	^ String maEmpty! !

!HandMorph methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!WeakSet methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:55'!
maBufferInstSize

	^ self slowSize! !

!WeakSet methodsFor: '*ma object serialization' stamp: 'cmm 3/7/2005 14:43'!
maStreamVariablyInto: aMaVariableObjectBuffer for: aMaObjectSerializer
	"If a GC has happened since we set aMaVariableObjectBuffer's logicalSize then, upon materialization, it may try to load with 'garbage' oids because we load up to the number of logicalSize instVars (and the buffer would have garbage at those places).  Therefore, reset the logicalSize after populating."
	super
		maStreamVariablyInto: aMaVariableObjectBuffer
		for: aMaObjectSerializer.
	aMaVariableObjectBuffer physicalSize: (aMaVariableObjectBuffer physicalSizeFor: self)! !

!SystemWindow methodsFor: '*ma object serialization' stamp: 'cmm 2/22/2005 12:49'!
maTransientVariables

	^ super maTransientVariables, #( 'owner' )! !

!Exception methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 13:13'!
maWantsPreSerialization 
	^ true! !

!UndefinedObject class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!UndefinedObject methodsFor: '*ma object serialization' stamp: ''!
maOid
	^MaOidCalculator oidForNil! !

!IdentitySet methodsFor: '*ma object serialization' stamp: 'cmm 6/28/2004 23:21'!
maIsEqualityHashedCollection

	^ false! !

MaObject subclass: #MaBlockContextStorage
	instanceVariableNames: 'nargs startpc home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaBlockContextStorage class methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:11'!
newFor: aBlockContext

	^ self new
		initializeFrom: aBlockContext ;
		yourself! !

!MaBlockContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:07'!
asBlockContext

	| methodContext |
	methodContext _ home asMethodContext.
	^ (BlockContext newForMethod: methodContext method)
		home: methodContext
		startpc: startpc
		nargs: nargs! !

!MaBlockContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:12'!
initializeFrom: aBlockContext

	nargs _ aBlockContext numArgs.
	startpc _ aBlockContext startpc.
	home _ MaMethodContextStorage newFor: aBlockContext home! !

MaObject subclass: #MaClassIdManager
	instanceVariableNames: 'classesById idsByClass nextClassId classDefinitionsById inImageDefinitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

MaClassIdManager class
	instanceVariableNames: 'MinimumClasses'!

!MaClassIdManager commentStamp: 'cmm 6/11/2004 16:53' prior: 0!
classDefinitionsById -- all versions of all classes that I know about
 inImageDefinitions -- the in-image version of each class I know about.!

!MaClassIdManager class methodsFor: 'accessing' stamp: 'cmm 10/27/2004 22:52'!
minimumClasses

	^ { Metaclass.  Class.
	MaClassDefinition.
	Boolean. SmallInteger. Character. Float. UndefinedObject.
	Array. Symbol. String. ByteArray. Set. OrderedCollection. Dictionary }! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 10/29/2004 11:01'!
addClassDefinition: aMaClassDefinition

	| definitions answer |
	definitions _ self ensureClassDefinitionsFor: aMaClassDefinition.
	(answer _ self definitionLike: aMaClassDefinition in: definitions)
		ifNil:
			[ answer _ aMaClassDefinition.
			definitions add: aMaClassDefinition.
			aMaClassDefinition version: definitions size ].
	answer isDefined ifTrue:
		[ self
			idOfClass: answer classObject
			is: answer id.
		self refreshInImageDefinition: answer classObject.
		(answer superclassDefinition isNil and: [ answer classObject superclass ~= nil ])
			ifTrue:
				[ self addNewClass: answer classObject superclass.
				answer initializeSuperclassDefinitionUsing: self ] ].
	answer superclassDefinition notNil
		ifTrue:
			[ self addClassDefinition: answer superclassDefinition ].
	^ answer! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 10/17/2004 22:38'!
addNewClass: aClass
	"Answer the storage definition created for aClass."

	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ self addClassDefinition: (MaClassDefinition className: aClass name)! !

!MaClassIdManager methodsFor: 'accessing' stamp: ''!
classDefinitionsById

	^classDefinitionsById
! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 6/29/2004 17:42'!
classDefinitionsById: aDictionary

	classDefinitionsById _ aDictionary! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/17/2004 22:39'!
classDefinitionsForClass: aClass

	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ self classDefinitionsForId: (self idForClass: aClass)! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/12/2004 22:15'!
classDefinitionsForId: anInteger

	^ self
		classDefinitionsForId: anInteger
		ifAbsent: [ MagmaSoftwareError signal: 'class-definition not found' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/12/2004 22:16'!
classDefinitionsForId: anInteger ifAbsent: aBlock

	^ anInteger
		ifNil: [ aBlock value ]
		ifNotNil:
			[ classDefinitionsById
				at: anInteger
				ifAbsent: aBlock ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/8/2004 16:13'!
classForId: anInteger

	^ self
		classForId: anInteger
		ifAbsent: [ self error: anInteger printString, ' is not a known class id.' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/22/2004 12:52'!
classForId: anInteger ifAbsent: aBlock

	^ anInteger <= self minimumClasses size
		ifTrue:
			[ self minimumClasses at: anInteger ]
		ifFalse:
			[ classesById
				at: anInteger
				ifAbsent: aBlock ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/17/2004 22:39'!
currentVersionOfClass: aClass

	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ (self
		inImageDefinition: aClass
		ifAbsent: [ ^ 1 ]) version! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 3/23/2005 13:25'!
definitionForClassId: classIdInteger version: classVersionInteger

	^ classVersionInteger = 0
		ifTrue: [ self inImageDefinition: (self classForId: classIdInteger) ]
		ifFalse: [ (self classDefinitionsForId: classIdInteger) at: classVersionInteger ]! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 10/13/2004 23:43'!
definitionLike: aMaClassDefinition in: definitionsCollection

	definitionsCollection isEmpty ifTrue: [ ^ nil ].
	(definitionsCollection anySatisfy: [ : each | each className = aMaClassDefinition className ]) ifFalse: [ ^ nil ].
	(definitionsCollection includes: aMaClassDefinition) ifTrue: [ ^ aMaClassDefinition ].
	^ definitionsCollection 
		detect: [ : eachDef | eachDef hasSameDefinitionAs: aMaClassDefinition ]
		ifNone: [ nil ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/14/2004 09:42'!
ensureClassDefinitionsFor: aMaClassDefinition
	"Look for the collection of versions of the same class that aMaClassDefinition is for.  If none exist create and answer the new collection that will hold aMaClassDefinition and its future versions."

	^ (aMaClassDefinition id notNil and: [ classDefinitionsById includesKey: aMaClassDefinition id ])
		ifTrue: [ classDefinitionsById at: aMaClassDefinition id ]
		ifFalse:
			[ classDefinitionsById 
				maDetect: [ : eachDefinitions | eachDefinitions anySatisfy: [ : each | each isKnownAs: aMaClassDefinition className ] ]
				ifFound:
					[ : foundDefinitions | 
					aMaClassDefinition id: foundDefinitions first id.
					foundDefinitions ]
				ifNone:
					[ "None found, let's create one."
					| id class |
					"First figure out the id."
					id _ aMaClassDefinition hasId
						ifTrue: [ aMaClassDefinition id ]
						ifFalse:
							[ "Make sure not one of the minimumClasses."
							((Smalltalk hasClassNamed: aMaClassDefinition className) and: [ self isMemberOfMinimumClasses: (class _ Smalltalk at: aMaClassDefinition className) ])
								ifTrue: [ self idForClass: class ]
								ifFalse: [ self nextClassId ] ].
					aMaClassDefinition id: id.
					classDefinitionsById
						at: id
						put: (OrderedCollection new: 1) ] ]! !

!MaClassIdManager methodsFor: 'event handling' stamp: 'cmm 10/1/2004 15:21'!
handleClassModification: aClass using: aMaObjectSerializer

	"Optional subclass hook."! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 10/15/2004 12:31'!
hasClassDefinitionFor: aClass

	| foundQuickly |
	foundQuickly _ inImageDefinitions
		maAt: aClass
		ifPresent: [ : definition | definition isPartOfClassDefinitions ]
		ifAbsent: [ false ].
	^ foundQuickly or:
		[ classDefinitionsById anySatisfy:
			[ : eachDefinitions |
			(eachDefinitions last isKnownAs: aClass name)
			and: [ eachDefinitions
				anySatisfy:
					[ : each | each hasSameDefinitionAs: aClass ] ] ] ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 8/26/2002 22:03'!
idForClass: aClass

	^self
		idForClass: aClass
		ifAbsent: [ MaSoftwareError signal: aClass name, ' has no id assigned.' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/17/2004 22:39'!
idForClass: aClass ifAbsent: aBlock

	| index |
	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ idsByClass
		at: aClass
		ifAbsent: 
			[ 
(index _ self minimumClasses indexOf: aClass) > 0
				ifTrue: [ index ]
				ifFalse: [ aBlock value ] ]! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 10/15/2004 12:06'!
idOfClass: aClass is: anInteger

	nextClassId _ nextClassId max: anInteger.
	classesById
		at: anInteger
		put: aClass.
	^idsByClass
		at: aClass
		put: anInteger
! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/6/2004 19:46'!
inImageDefinition: aClass

	^ self
		inImageDefinition: aClass
		ifAbsent: [ self error: aClass name, ' is not part of my inImageDefinitions.' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/15/2004 11:58'!
inImageDefinition: aClass ifAbsent: aBlock

	^ inImageDefinitions
		at: (aClass isMeta ifTrue: [ Metaclass ] ifFalse: [ aClass ])
		ifAbsent: aBlock! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 6/30/2004 00:03'!
includesIdForClass: aClass

	^ idsByClass includesKey: aClass! !

!MaClassIdManager methodsFor: 'copy' stamp: 'cmm 3/24/2005 12:06'!
independentCopy

	^ self copy postIndependentCopy! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 6/29/2004 17:47'!
initialize

	super initialize.
	idsByClass _ Dictionary new.
	classesById _ Dictionary new.
	nextClassId _ 100.
	inImageDefinitions _ Dictionary new.
	self classDefinitionsById: Dictionary new.
	self initializeMinimumClasses! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 6/11/2004 16:56'!
initializeMinimumClasses

	self minimumClasses do: [ : each | self addNewClass: each ]! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 10/17/2004 22:39'!
isMemberOfMinimumClasses: aClass
	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ self minimumClasses includes: aClass! !

!MaClassIdManager methodsFor: 'accessing' stamp: ''!
minimumClasses

	^self class minimumClasses
! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 8/15/2002 23:53'!
nextClassId

	^nextClassId _ nextClassId + 1
! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 3/26/2003 23:21'!
numberOfClasses

	^classesById size
! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 3/24/2005 12:05'!
postIndependentCopy

	classesById _ classesById copy.
	idsByClass _ idsByClass copy.
	classDefinitionsById _ classDefinitionsById copy.
	inImageDefinitions _ inImageDefinitions copy! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 1/16/2005 22:16'!
refreshInImageDefinition: aClass
	"Whenever the user recompiles a class in the image (e.g., during development)."

	({ Object. ProtoObject } includes: aClass)
		ifTrue:
			[ (self hasClassDefinitionFor: aClass)
				ifTrue:
					[ inImageDefinitions
						at: aClass
						ifAbsentPut: [ (self classDefinitionsForClass: aClass) last ].
			^ self  "performance" ] ].
	aClass withAllSubclassesDo:
		[ : eachClass |  	| knownDefinitions |
		(eachClass = aClass or: [ self includesIdForClass: eachClass ])
			ifTrue:
				[ knownDefinitions _ (self hasClassDefinitionFor: eachClass)
					ifTrue: [ self classDefinitionsForClass: eachClass ]
					ifFalse: [ #() ].
				inImageDefinitions
					at: eachClass
					put:
						(knownDefinitions
							maDetect: [ : each | each hasSameDefinitionAs: eachClass ]
							ifFound:
								[ : foundDef |
								"In the rare case, where a classdef was materialized but not defined in the image, so it was added to definitions only.  Now we're defining it so we need to be sure we set up its mappings."
								self
									idOfClass: eachClass
									is: foundDef id.
								foundDef ]
							ifNone: [ MaClassDefinition className: eachClass name ]) ] ]! !

MaObject subclass: #MaCompiledMethodStorage
	instanceVariableNames: 'header literals startPc endPc byteCodes sourcePointer selector className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaCompiledMethodStorage class methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:12'!
newFor: aCompiledMethod

	^ self new
		initializeFrom: aCompiledMethod ;
		yourself! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/25/2004 23:34'!
asCompiledMethod

	| answer |
	answer _ 
		CompiledMethod 
			newMethod: endPc - startPc + 1 + 4
			header: header.
	literals withIndexDo: 
		[ : each : index |
		answer
			literalAt: index
			put: each ].
"	answer setSourcePointer: sourcePointer."  "<-- don't restore it, it could be wrong."
"In fact..."
sourcePointer > 0 ifTrue: [ answer zapSourcePointer ].
	answer
		replaceFrom: startPc
		to: endPc
		with: byteCodes
		startingAt: 1.
	self restoreLiterals: answer.
	^ answer! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 2/22/2005 10:03'!
cleanLiterals: aCompiledMethod
	"Strip class-var objects from anArray (nil them out).  Class vars are not stored, but we will try to hook them up by name upon materialization."
	| answer |
	answer _ aCompiledMethod literals.
	answer withIndexDo:
		[ : eachLiteral : index |
		(eachLiteral isVariableBinding
		and: [ eachLiteral isSpecialWriteBinding not
		and: [ eachLiteral key notNil
		and: [ (Smalltalk includesKey: eachLiteral key) not ] ] ])
			ifTrue:
				[ answer at: index put: eachLiteral copy.
				"nil out the global object, we will remap to it by name upon materialization (see restoreLiterals:)."
				(answer at: index) value: nil ] ].
	^ answer! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/14/2004 19:12'!
initializeFrom: aCompiledMethod

	className _ aCompiledMethod maMethodClass name.
	selector _ aCompiledMethod selector.
	literals _ self cleanLiterals: aCompiledMethod.
	header _ aCompiledMethod header.
	sourcePointer _ aCompiledMethod sourcePointer.
	startPc _ aCompiledMethod initialPC.
	endPc _ aCompiledMethod endPC.
	byteCodes _ ByteArray new: endPc - startPc + 1.
	byteCodes
		replaceFrom: 1
		to: byteCodes size
		with: aCompiledMethod
		startingAt: startPc! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 2/22/2005 10:05'!
restoreLiterals: aCompiledMethod
	"This method attempts to logically restore any reference to class-vars in aCompiledMethod.  Even though aCompiledMethod is not installed in the system, I saved its class and selector during serialization, now I can use that information to, if present, re-hook up the class variable up to the one in this image." 

	aCompiledMethod literals withIndexDo:
		[ : eachLiteral : index |
		(eachLiteral isVariableBinding
		and: [ eachLiteral isSpecialWriteBinding not ])
			ifTrue:
				[ | methodClass classVarNames classBinding |
				methodClass _ Smalltalk at: className ifAbsent: [ nil ].
				classBinding _ (eachLiteral key notNil and: [ methodClass notNil and: [ methodClass allClassVarNames includes: eachLiteral key ] ])
					ifTrue: [ methodClass bindingOf: eachLiteral key ]
					ifFalse:
						[ "Ok, not a class-var (at least not any more), check to see if its a Smalltalk global."
						(eachLiteral key notNil and: [ (Smalltalk includesKey: eachLiteral key) not ])
							ifTrue:
								[ ^ MaObjectSerializationWarning signal: 'Warning, cannot remap ', className, '>>''', eachLiteral key asString, ''' because that global is no longer defined.  nil will be substituted.' ].
						eachLiteral ].
				aCompiledMethod
					literalAt: index
					put: classBinding ] ]! !

MaObject subclass: #MaGlobalReference
	instanceVariableNames: 'globalName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

MaGlobalReference subclass: #MaClassReference
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

MaClassReference subclass: #MaClassDefinition
	instanceVariableNames: 'instVarNames version superclassDefinition category type comment commentStamp classVarNames poolDictionaryNames classInstVarNames aliases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaClassDefinition class methodsFor: 'creation' stamp: 'cmm 6/16/2004 11:26'!
className: aSymbol

	^(super className: aSymbol)
		initializeFrom: (Smalltalk classNamed: aSymbol) ;
		yourself! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 10/13/2004 23:49'!
addAlias: aSymbol
	"When my class is renamed, my old name beccomes one of my aliases.  This is necessary to accomodate further changes to my definition in clients that have not yet compiled the renamed version of me."

	aliases add: aSymbol! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 12/19/2002 21:45'!
allInstVarNames
	^instVarNames! !

!MaClassDefinition methodsFor: 'actions' stamp: 'cmm 1/26/2005 13:06'!
allSuperclassDefinitionsDo: oneArgBlock
	"Value oneArgBlock with each of my superclass-definitions, in turn."

	superclassDefinition ifNotNil: [ superclassDefinition withAllSuperclassDefinitionsDo: oneArgBlock ]! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:38'!
classInstanceVariablesString
	^ self stringForVariables: classInstVarNames! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 10/13/2004 23:52'!
className: newClassName

	self className ifNotNil: [ aliases add: self className ].
	super className: newClassName! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:37'!
classVariablesString
	^ self stringForVariables: classVarNames! !

!MaClassDefinition methodsFor: 'actions' stamp: 'cmm 3/8/2005 13:51'!
createClassUsing: aMaObjectSerializer
	| superClass |
	superClass _ self superclassDefinition ensureClassUsing: aMaObjectSerializer.
	^ SystemChangeNotifier uniqueInstance doSilently:
		[ ((ClassBuilder new)
			name: self className
			inEnvironment: superClass environment 
			subclassOf: superClass
			type: type 
			instanceVariableNames: self instanceVariablesString 
			classVariableNames: self classVariablesString 
			poolDictionaries: self sharedPoolsString
			category: category)
			
			ifNotNilDo:
				[ : class |
				aMaObjectSerializer classIdManager
					idOfClass: class
					is: self id.
				class class instanceVariableNames: self classInstanceVariablesString.
				class hasComment
					ifTrue: 
						[ class 
							classComment: comment 
							stamp: commentStamp ].
				aMaObjectSerializer classIdManager refreshInImageDefinition: class.
				class ] ]! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 10/27/2004 23:34'!
ensureClassUsing: aMaObjectSerializer

	^ self isDefined
		ifTrue: [ self classObject ]
		ifFalse: [ self createClassUsing: aMaObjectSerializer ]! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 10/13/2004 16:44'!
hasSameDefinitionAs: aClassOrMaClassDefinition

	^ self allInstVarNames maMatchesElementsOf: aClassOrMaClassDefinition allInstVarNames! !

!MaClassDefinition methodsFor: 'converting' stamp: 'cmm 6/16/2004 22:40'!
indexOfInstVarCorrespondingTo: instVarIndex of: anotherMaClassDefinition
	"Answer the index of the instVar in me that corresponds to the one at instVarIndex in anotherMaClassDefinition."

	self == anotherMaClassDefinition ifTrue: [ ^ instVarIndex ].
	"different versions, determine if instVarIndex refers to a named or indexed var"
	^ instVarIndex > anotherMaClassDefinition allInstVarNames size
		ifTrue:
			[ "indexed inst var" 
			self allInstVarNames size + (instVarIndex - anotherMaClassDefinition allInstVarNames size) ]
		ifFalse:
			[ "find the instVar with the same name."
			self allInstVarNames
				indexOf: (anotherMaClassDefinition allInstVarNames at: instVarIndex) ]! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 10/13/2004 23:50'!
initialize

	super initialize.
	self version: 0.
	aliases _ OrderedCollection new! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 6/10/2004 23:43'!
initializeFrom: aClass

	self globalName: aClass name.
	instVarNames _ aClass allInstVarNames.
	classVarNames _ aClass classVarNames.
	poolDictionaryNames _ aClass poolDictionaryNames.
	classInstVarNames _ aClass class instVarNames.
	category _ aClass category.
	type _ aClass typeOfClass.
	comment _ aClass organization classComment asString.
	commentStamp _ aClass organization commentStamp! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 6/11/2004 00:33'!
initializeSuperclassDefinitionUsing: aMaClassIdManager

	| superclassDefinitions |
	superclassDefinitions _ aMaClassIdManager classDefinitionsForClass: self classObject superclass.
	superclassDefinition _
		superclassDefinitions
			detect: [ : each | each hasSameDefinitionAs: self classObject superclass ]
			ifNone: [ aMaClassIdManager inImageDefinition: self classObject superclass ]! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 10/13/2004 13:03'!
instanceVariablesString

	^ self stringForVariables: (instVarNames copyWithoutAll: superclassDefinition allInstVarNames)! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 6/8/2004 15:58'!
isDefined

	^ Smalltalk hasClassNamed: self className! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 10/13/2004 23:53'!
isKnownAs: className

	^ self name = className
	or: [ aliases includes: className ]! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 6/7/2004 21:35'!
isPartOfClassDefinitions

	^ version > 0! !

!MaClassDefinition methodsFor: 'converting' stamp: 'cmm 1/20/2003 00:49'!
maAsStorageObject

	^self! !

!MaClassDefinition methodsFor: 'printing' stamp: 'cmm 6/24/2004 14:42'!
maPrintAbbreviatedOn: aStream

	super maPrintAbbreviatedOn: aStream.
	self
		maPrintAttribute: #version
		on: aStream! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 11/26/2004 15:12'!
maWantsPostMaterialization
	^ true! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 12/19/2002 21:43'!
namedInstSize
	^self allInstVarNames size! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 6/16/2004 14:48'!
representsClassInImage

	^ (Smalltalk hasClassNamed: self className)
	and: [ self hasSameDefinitionAs: self classObject ]! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:35'!
sharedPoolsString
	^ self stringForVariables: poolDictionaryNames! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:34'!
stringForVariables: aCollection

	^ String streamContents:
		[ :stream |
		aCollection
			do: [ :ea | stream nextPutAll: ea ]
			separatedBy: [ stream space ] ]! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 6/11/2004 00:55'!
superclassDefinition

	^ superclassDefinition! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 6/10/2004 23:49'!
superclassName

	^ superclassDefinition className! !

!MaClassDefinition methodsFor: 'accessing' stamp: ''!
version

	^version! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 6/23/2004 13:49'!
version: anInteger

	version _ anInteger
! !

!MaClassDefinition methodsFor: 'actions' stamp: 'cmm 10/17/2004 15:04'!
withAllSuperclassDefinitionsDo: oneArgBlock
	"Value oneArgBlock with myself, then each of my superclass-definitions, in turn."

	oneArgBlock value: self.
	superclassDefinition ifNotNil: [ superclassDefinition withAllSuperclassDefinitionsDo: oneArgBlock ]! !

!MaClassReference class methodsFor: 'creation' stamp: 'cmm 6/28/2004 18:05'!
className: aSymbol

	^ self globalName: aSymbol! !

!MaClassReference methodsFor: 'accessing' stamp: ''!
className

	^self globalName
! !

!MaClassReference methodsFor: 'building' stamp: ''!
className: aSymbol

	self globalName: aSymbol
! !

!MaClassReference methodsFor: 'accessing' stamp: ''!
classObject

	^self globalObject
! !

!MaClassReference methodsFor: 'accessing' stamp: 'cmm 6/23/2004 00:03'!
hasId

	^ self id notNil! !

!MaClassReference methodsFor: 'accessing' stamp: ''!
id

	^id
! !

!MaClassReference methodsFor: 'building' stamp: ''!
id: anInteger

	id _ anInteger
! !

!MaClassReference methodsFor: 'converting' stamp: 'cmm 1/5/2003 16:19'!
maAsStorageObject
	"Some objects should be converted to another object before being stored
	in a buffer."

	^self name! !

!MaClassReference methodsFor: 'accessing' stamp: 'cmm 1/1/2003 23:52'!
name
	"For interface compatibility with Class."

	^self className! !

!MaGlobalReference class methodsFor: 'creation' stamp: ''!
globalName: aSymbol

	^self new globalName: aSymbol
! !

!MaGlobalReference methodsFor: 'private' stamp: ''!
globalName

	^globalName! !

!MaGlobalReference methodsFor: 'private' stamp: ''!
globalName: aSymbol

	globalName _ aSymbol
! !

!MaGlobalReference methodsFor: 'accessing' stamp: 'cmm 6/28/2004 14:29'!
globalObject

	^Smalltalk
		at: self globalName
		ifAbsent:
			[ MaObjectSerializationSoftwareError signal: self globalName, ' not defined in this image.'.
			self ]! !

!MaGlobalReference methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: self globalName
! !

MaObject subclass: #MaMethodContextStorage
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaMethodContextStorage class methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:11'!
newFor: aMethodContext

	^ self new
		initializeFrom: aMethodContext ;
		yourself! !

!MaMethodContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/12/2004 16:37'!
asMethodContext

	| cm |
	^ (MethodContext newForMethod: (cm _ method asCompiledMethod))
		privRefreshWith: cm ;
		yourself! !

!MaMethodContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:14'!
initializeFrom: aMethodContext

	method _ MaCompiledMethodStorage newFor: aMethodContext method! !

MaObject subclass: #MaObjectBuffer
	instanceVariableNames: 'byteArray startPos'
	classVariableNames: 'BufferClasses'
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaObjectBuffer commentStamp: 'cmm 10/21/2004 12:41' prior: 0!
This class encapsulates a single object into its byteArray.  The 0-based buffer positions of my fields are:

	0 = oid (8 bytes)
	8 = physicalSize (3 bytes)
	11 = bufferType (1 byte)
	12 = classId (2 bytes)!

MaObjectBuffer subclass: #MaClassReferenceBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaClassReferenceBuffer commentStamp: 'cmm 10/27/2004 22:22' prior: 0!
I represent a buffer that, when materializes, answers the class in the host Smalltalk image for the definition with my id.

	at position 14 is the representedClassId!

!MaClassReferenceBuffer methodsFor: 'accessing' stamp: 'cmm 10/27/2004 22:22'!
bufferPositionOfRepresentedClassId

	^ 14! !

!MaClassReferenceBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:31'!
bufferType
	^ 4! !

!MaClassReferenceBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 12:53'!
createObjectUsing: aMaObjectSerializer
	^ (self ensureClassUsing: aMaObjectSerializer)
		maMaterializeFrom: self
		using: aMaObjectSerializer! !

!MaClassReferenceBuffer methodsFor: 'private' stamp: 'cmm 10/30/2004 16:31'!
physicalDataSizeNeededFor: anObject

	^ 0! !

!MaClassReferenceBuffer methodsFor: 'building' stamp: 'cmm 11/23/2004 10:56'!
populateBodyFor: storageObject using: aMaObjectSerializer
	"Class-reference buffers have no body."! !

!MaClassReferenceBuffer methodsFor: 'building' stamp: 'cmm 11/1/2004 12:28'!
populateHeaderFor: aBehavior storageObject: storageObject using: aMaObjectSerializer
	"physicalSize was already set in ensureSpaceFor:, no need to calculate it again."
	super
		populateHeaderFor: aBehavior
		storageObject: storageObject
		using: aMaObjectSerializer.
	self
		representedClassId: 
			(aMaObjectSerializer classIdManager
				idForClass: aBehavior theNonMetaClass
				ifAbsent: [ (aMaObjectSerializer classIdManager addNewClass: aBehavior theNonMetaClass) id ])! !

!MaClassReferenceBuffer methodsFor: 'accessing' stamp: 'cmm 10/27/2004 22:20'!
representedClassId

	^ self 
		uint: 16
		at: self bufferPositionOfRepresentedClassId! !

!MaClassReferenceBuffer methodsFor: 'accessing' stamp: 'cmm 10/27/2004 22:20'!
representedClassId: anInteger

	^ self 
		uint: 16
		at: self bufferPositionOfRepresentedClassId
		put: anInteger! !

MaObjectBuffer subclass: #MaFixedObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaFixedObjectBuffer commentStamp: 'cmm 10/21/2004 13:13' prior: 0!
This class encapsulates an object that has a fixed-size.  Most objects are fixed-sizevariable logical size, primarily Smalltalk collections including Byte-oriented collections such as ByteArray and String.

My 0-based buffer fields are:

	(see superclass)
	14 = classVersion (2 bytes)!

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 22:05'!
bufferPositionOfClassVersion
	"Zero-based position."

	^ 17! !

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:32'!
bufferType
	^ 3! !

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 22:05'!
classVersion

	^self 
		uint: 16
		at: self bufferPositionOfClassVersion
! !

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 22:05'!
classVersion: anInteger

	self
		uint: 16
		at: self bufferPositionOfClassVersion
		put: anInteger
! !

!MaFixedObjectBuffer methodsFor: 'creation' stamp: 'cmm 12/2/2004 12:35'!
createObjectUsing: aMaObjectSerializer
	| class skeleton indexedSize sourceDefinition inImageDefinition |
	class _ self ensureClassUsing: aMaObjectSerializer.
	sourceDefinition _ 
		aMaObjectSerializer classIdManager
			definitionForClassId: self classId
			version: self classVersion.
	inImageDefinition _ aMaObjectSerializer classIdManager inImageDefinition: class.
	indexedSize _ self objectInstSize - sourceDefinition namedInstSize.
	skeleton _ indexedSize = 0 ifTrue: [ class basicNew ] ifFalse: [ class basicNew: indexedSize ].
	self instVarsDoWithIndex:
		[ : eachOid : sourceIndex |  | targetIndex |
		targetIndex _
			inImageDefinition
				indexOfInstVarCorrespondingTo: sourceIndex
				of: sourceDefinition.
		targetIndex > 0 
			ifTrue:
				[ skeleton
					instVarAt: targetIndex
					put: eachOid ]
			ifFalse:
				[ eachOid = MaOidCalculator oidForNil
					ifFalse: 	[ aMaObjectSerializer recordTruncatedObject: skeleton ] ] ].
	^ skeleton! !

!MaFixedObjectBuffer methodsFor: 'building' stamp: 'cmm 11/22/2004 14:42'!
establishReferencesFrom: anObject using: aMaObjectSerializer

	1
		to: anObject maInstSize
		do:
			[ : instVarIndex | | oid |
			oid _ anObject instVarAt: instVarIndex.
			oid ifNotNil: "could be nil if different class def"
				[ anObject
	
				instVarAt: instVarIndex
	
				put: (
	
					aMaObjectSerializer
	
						objectWithOid: oid
	
						ifAbsent: [ aMaObjectSerializer proxyFor: oid ]) ] ]! !

!MaFixedObjectBuffer methodsFor: 'building' stamp: 'cmm 11/29/2004 16:56'!
populateBodyFor: storageObject using: aMaObjectSerializer
	1
		to: storageObject maInstSize
		do:
			[ :index |
			self
				maInstVarAt: index
				put:
					((storageObject maIsTransient: index)
						ifTrue: [ MaOidCalculator oidForNil ]
						ifFalse: [ aMaObjectSerializer oidFor: (storageObject instVarAt: index) ]) ]! !

!MaFixedObjectBuffer methodsFor: 'building' stamp: 'cmm 10/21/2004 23:18'!
populateHeaderFor: anObject storageObject: storageObject using: aMaObjectSerializer

	| classVersion |
	super
		populateHeaderFor: anObject
		storageObject: storageObject
		using: aMaObjectSerializer.
	classVersion _ 
		aMaObjectSerializer classIdManager
			currentVersionOfClass: (aMaObjectSerializer classFor: anObject).
	self classVersion: classVersion! !

!MaFixedObjectBuffer methodsFor: 'printing' stamp: 'cmm 12/1/2004 23:43'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(classVersion oids)
		on: aStream! !

!MaObjectBuffer class methodsFor: 'private accessing' stamp: 'cmm 1/27/2003 23:50'!
bufferClassFor: aByteArray startPos: anInteger

	^self bufferClasses at: 
		(aByteArray 
			maUint: 8
			at: anInteger + self bufferPositionOfBufferType)! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 7/15/2002 23:04'!
bufferClasses

	^BufferClasses! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 10/20/2004 22:14'!
bufferPositionOfBufferType

	^11! !

!MaObjectBuffer class methodsFor: 'private accessing' stamp: ''!
bufferPositionOfPhysicalSize
	"Zero-based logical position within this buffer's byteArray that contains the
	physical size of this buffer."

	^8
! !

!MaObjectBuffer class methodsFor: 'creation' stamp: 'cmm 7/10/2002 20:27'!
byteArray: aByteArray startPos: anInteger

	^self new
		startPos: anInteger;
		byteArray: aByteArray
! !

!MaObjectBuffer class methodsFor: 'creation' stamp: 'cmm 7/10/2002 20:28'!
createFromByteArray: aByteArray startPos: anInteger

	^(self
		bufferClassFor: aByteArray
		startPos: anInteger)
			byteArray: aByteArray
			startPos: anInteger
! !

!MaObjectBuffer class methodsFor: 'required overrides' stamp: 'cmm 10/21/2004 23:19'!
headerSize
	"The number of bytes in each object record before the data for the object begins."

	^ 24! !

!MaObjectBuffer class methodsFor: 'initializing' stamp: 'cmm 11/19/2004 15:13'!
initialize
	"Called from preamble of MaObjectSerialization."

	BufferClasses _ Array
		with: MaByteObjectBuffer
		with: MaVariableObjectBuffer
		with: MaFixedObjectBuffer
		with: MaClassReferenceBuffer
		with: MaVariableWordBuffer! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 3/23/2005 13:40'!
oidSize

	^ 64! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
bufferPositionOfBufferType

	^self class bufferPositionOfBufferType
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 12:41'!
bufferPositionOfClassId
	"Zero-based position of the class id."

	^ 12! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 11/19/2004 15:52'!
bufferPositionOfInstVarAt: anInteger
	"Answer the physical 0-based byte-position within the receivers byteArray
	where the instVar with index anInteger is located."

	^ self headerSize + ((anInteger - 1) * self slotSize)! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
bufferPositionOfOid
	"Zero-based position within a buffer that the oid is at."

	^0
! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
bufferPositionOfPhysicalSize
	"Zero-based logical position within the byteArray that contains the
	physical size of this portion of the buffer (e.g., not including continuations)."

	^self class bufferPositionOfPhysicalSize
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/19/2004 16:27'!
bufferType

	^ self subclassResponsibility! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
byteArray

	^byteArray! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
byteArray: aByteArray

	byteArray _ aByteArray
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 12:41'!
classId

	^self 
		uint: 16
		at: self bufferPositionOfClassId
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 12:41'!
classId: anInteger

	self
		uint: 16
		at: self bufferPositionOfClassId
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/30/2004 16:00'!
classVersion

	^ 1! !

!MaObjectBuffer methodsFor: 'copying' stamp: 'cmm 3/24/2005 12:02'!
copyWithNewBuffer

	^ self copy postCopyWithNewBuffer! !

!MaObjectBuffer methodsFor: 'copying' stamp: 'cmm 10/10/2004 00:03'!
copyWithSameBuffer

	^ self copy! !

!MaObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 12:44'!
createObjectUsing: aMaObjectSerializer
	self subclassResponsibility! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/21/2004 23:29'!
ensureClassUsing: aMaObjectSerializer

	^ (aMaObjectSerializer classIdManager
		classForId: self classId
		ifAbsent:
			[ "going to materialize an instance of the missing class."
			| sourceDefinition |
			sourceDefinition _
				(aMaObjectSerializer classIdManager classDefinitionsForId: self classId) last.  "the most-recent one is the best guess."
			sourceDefinition createClassUsing: aMaObjectSerializer ])! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/21/2004 22:43'!
ensureSpaceFor: storageObject

	| totalSize requiredSpace |
	requiredSpace _ self physicalSizeFor: storageObject.
	(totalSize _ requiredSpace + self startPos) > 10000000
		ifTrue:
			 [ MaObjectSerializationSecurityViolation signal: 'Serializations beyond 10 megabytes are not allowed.' ].
	totalSize > byteArray size ifTrue: [ self growTo: totalSize*2 ].
	self physicalSize: requiredSpace! !

!MaObjectBuffer methodsFor: 'debugging' stamp: 'cmm 1/19/2005 16:47'!
equals: aMaObjectBuffer

	^(byteArray
		copyFrom: startPos + 1
		to: startPos + self physicalSize) = (
		aMaObjectBuffer byteArray
			copyFrom: aMaObjectBuffer startPos + 1
			to: aMaObjectBuffer startPos + self physicalSize)
! !

!MaObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/22/2004 14:40'!
establishReferencesFrom: anObject using: aMaObjectSerializer
	"This is the second-stage of materializing anObject.  The first stage populated its instVars with oids, this stage now replaces those oids with the actual objects.  Typically, only Fixed and VariableObject buffers will need to do anything on this."! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:09'!
growTo: anInteger

	self byteArray: (
		(ByteArray new: anInteger)
			replaceFrom: 1
			to: byteArray size
			with: byteArray
			startingAt: 1)
! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
headerSize
	"The number of bytes in each object record before the addresses of its
	'data' (instance variables, in the case of a NormalObjectBuffer) begins.
	The zero-based position in any buffer where the value of the object
	is stored, either the actual value or the address to it."

	^self class headerSize
! !

!MaObjectBuffer methodsFor: 'copying' stamp: 'cmm 3/24/2005 12:00'!
independentCopy

	^ self copy postIndependentCopy! !

!MaObjectBuffer methodsFor: 'initializing' stamp: ''!
initialize

	super initialize.
	startPos _ 0
! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 12/2/2004 12:35'!
instVarsDoWithIndex: twoArgBlock

	1
		to: self objectInstSize
		do:
			[ :index |
			twoArgBlock
				value: (self maInstVarAt: index)
				value: index ]
! !

!MaObjectBuffer methodsFor: 'testing' stamp: 'cmm 10/21/2004 22:46'!
isBytes

	^ false! !

!MaObjectBuffer methodsFor: 'testing' stamp: 'cmm 2/8/2005 18:00'!
isPointers

	^ true! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 11/11/2004 16:14'!
loadFrom: aMaObjectBuffer
	"Make all of my fields the same values as those in aMaObjectBuffer.  This should be used only if you know what you're doing."
	byteArray
		replaceFrom: startPos
		to: startPos + aMaObjectBuffer physicalSize - 1
		with: aMaObjectBuffer byteArray
		startingAt: aMaObjectBuffer startPos! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 10/21/2004 23:42'!
maInstVarAt: anInteger 

	^ self 
		uint: 64
		at: (self bufferPositionOfInstVarAt: anInteger)! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 10/21/2004 23:42'!
maInstVarAt: anInteger put: oid

	self
		uint: 64
		at: (self bufferPositionOfInstVarAt: anInteger)
		put: oid
! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 12/2/2004 12:35'!
objectInstSize
	"Answer the capacity of this buffer to hold references to other objects."

	^ self objectSize / self slotSize! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 12/2/2004 12:34'!
objectSize

	^ self physicalSize - self headerSize! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:58'!
oid

	^self 
		uint: 64
		at: self bufferPositionOfOid
! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:41'!
oid: anInteger

	self
		uint: 64
		at: self bufferPositionOfOid
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'reference access' stamp: 'cmm 12/2/2004 12:35'!
oids
	"This method is intended for printing only.  Use oidsDoWithIndex: if you need to enumerate my oids."

	| oids |
	self objectInstSize isInteger ifFalse: [ ^ '** invalid **' ].
	oids _ OrderedCollection new.
	1
		to: self objectInstSize
		do: [ :index | oids add: (self maInstVarAt: index) ].
	^ oids! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 12/1/2004 22:54'!
physicalDataSizeNeededFor: storageObject

	^ storageObject maSizeIn: self! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/20/2004 22:44'!
physicalSize
	"See method comment for more info."

	^self 
		uint: 24
		at: self bufferPositionOfPhysicalSize
! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 3/24/2005 14:10'!
physicalSize: anInteger

	self
		uint: 24
		at: self bufferPositionOfPhysicalSize
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/21/2004 22:25'!
physicalSizeFor: storageObject

	^ self headerSize + (self physicalDataSizeNeededFor: storageObject)! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 11/21/2004 18:53'!
populateBodyFor: storageObject using: aMaObjectSerializer
	self subclassResponsibility! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 10/21/2004 23:16'!
populateHeaderFor: anObject storageObject: storageObject using: aMaObjectSerializer
	"physicalSize was already set in ensureSpaceFor:, no need to calculate it again."
	self
		oid: (aMaObjectSerializer oidFor: anObject) ;
		type: self bufferType ;
		classId:
			(aMaObjectSerializer classIdManager
				idForClass: anObject maSerializationClass
				ifAbsent: [ (aMaObjectSerializer classIdManager addNewClass: anObject maSerializationClass) id ])! !

!MaObjectBuffer methodsFor: 'copying' stamp: 'cmm 3/24/2005 12:01'!
postCopyWithNewBuffer

	byteArray _ byteArray copy! !

!MaObjectBuffer methodsFor: 'copying' stamp: 'cmm 3/24/2005 12:00'!
postIndependentCopy

	byteArray _ byteArray copy
! !

!MaObjectBuffer methodsFor: 'printing' stamp: 'cmm 2/23/2005 14:39'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(oid classId objectInstSize)
		on: aStream
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 11:08'!
slotSize
	^ 8! !

!MaObjectBuffer methodsFor: 'accessing' stamp: ''!
startPos

	^startPos! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
startPos: anInteger

	startPos _ anInteger
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 23:22'!
type
	"Answer the type of buffer this is.
		1=MaByteObjectBuffer
		2=MaVariableObjectBuffer
		3=MaFixedObjectBuffer"

	^ self 
		uint: 8
		at: self bufferPositionOfBufferType! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:41'!
type: anInteger

	self
		uint: 8
		at: self bufferPositionOfBufferType
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:09'!
uint: numberOfBits at: position

	^byteArray
		maUint: numberOfBits
		at: self startPos + position
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:10'!
uint: numberOfBits at: zeroBasedIndexPosition put: valueInteger

	^byteArray
		maUint: numberOfBits
		at: self startPos + zeroBasedIndexPosition
		put: valueInteger
! !

MaObjectBuffer subclass: #MaVariableBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaVariableBuffer commentStamp: 'cmm 12/1/2004 23:13' prior: 0!
This class encapsulates an object that has a variable logical size, primarily Smalltalk collections including Byte-oriented collections such as ByteArray and String.

I add no additional fields, only behavior.!

MaVariableBuffer subclass: #MaByteObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaByteObjectBuffer commentStamp: '<historical>' prior: 0!
I encapsulate objects that represented as a series of bytes; such as Strings, ByteArrays, CompiledMethods, etc.

!

!MaByteObjectBuffer methodsFor: 'converting' stamp: 'cmm 12/1/2004 22:47'!
asByteArray

	^ self asByteObject: ByteArray! !

!MaByteObjectBuffer methodsFor: 'converting' stamp: 'cmm 2/23/2005 14:38'!
asByteObject: byteClass

	^ self fillByteObject: (byteClass new: self objectSize)! !

!MaByteObjectBuffer methodsFor: 'converting' stamp: 'cmm 12/1/2004 22:47'!
asString

	^ self asByteObject: String! !

!MaByteObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:32'!
bufferType
	^ 1! !

!MaByteObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 22:41'!
createObjectUsing: aMaObjectSerializer
	"Objects with byte-based storage-objects can and do materialize now, rather than pointer-based storage-objects, which aren't actually well-formed until after establishingReferencesFrom:."
	^ (self ensureClassUsing: aMaObjectSerializer)
		maMaterializeFrom: self
		using: aMaObjectSerializer! !

!MaByteObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:10'!
fillByteObject: byteObject

	^byteObject
		replaceFrom: 1
		to: byteObject size
		with: byteArray
		startingAt: self startPos + self headerSize + 1.
! !

!MaByteObjectBuffer methodsFor: 'testing' stamp: 'cmm 10/8/2004 12:09'!
isBytes

	^ true! !

!MaByteObjectBuffer methodsFor: 'testing' stamp: 'cmm 2/8/2005 18:01'!
isPointers

	^ false! !

!MaByteObjectBuffer methodsFor: 'actions' stamp: 'cmm 11/21/2004 19:04'!
populateBodyFor: storageObject using: aMaObjectSerializer

	self
		replaceFrom: 1
		to: storageObject size
		with: storageObject
		startingAt: 1! !

!MaByteObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:10'!
replaceFrom: startInteger to: endInteger with: byteObject startingAt: startingInteger

	byteArray
		replaceFrom: self startPos + self headerSize + startInteger
		to: self startPos + self headerSize + endInteger
		with: byteObject
		startingAt: startingInteger
! !

!MaByteObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 11:08'!
slotSize

	^ 1! !

!MaVariableBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 12:41'!
numberToStoreFor: anObject using: aMaObjectSerializer
	"This method stores either anObject itself or the oid for anInteger."
	self subclassResponsibility! !

MaVariableBuffer subclass: #MaVariableObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaVariableObjectBuffer commentStamp: 'cmm 10/21/2004 22:05' prior: 0!
This class encapsulates variably-sized objects that reference objects.

My buffer fields are (these are 0-based indexes, sorry):

	(see superclass)
	24 = inst var #1!

!MaVariableObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:33'!
bufferType
	^ 2! !

!MaVariableObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 12:44'!
createObjectUsing: aMaObjectSerializer
	| class |
	class _ self ensureClassUsing: aMaObjectSerializer.
	"Set and Dictionary are special-case for this because we store their logical rather than physical representation.  Therefore, dispatch to the class to build the skeleton for VariableObjectBuffers."
	^ class maLoadVariableObjectFrom: self! !

!MaVariableObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 10:28'!
establishReferencesFrom: anObject using: aMaObjectSerializer
	"Set and Dictionary require special-case processing, therefore we dispatch."
	anObject maEstablishPointerReferencesUsing: aMaObjectSerializer! !

!MaVariableObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 12:41'!
numberToStoreFor: anObject using: aMaObjectSerializer
	^ aMaObjectSerializer oidFor: anObject! !

!MaVariableObjectBuffer methodsFor: 'building' stamp: 'cmm 11/28/2004 16:21'!
populateBodyFor: storageObject using: aMaObjectSerializer
	"Logical storage of collections varies by collection, therefore dispatch back to it."
	storageObject
		maStreamVariablyInto: self
		for: aMaObjectSerializer! !

!MaVariableObjectBuffer methodsFor: 'printing' stamp: 'cmm 12/1/2004 23:43'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(oids)
		on: aStream
! !

MaVariableBuffer subclass: #MaVariableWordBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:06'!
bufferPositionOfInstVarAt: anInteger
	"Answer the physical 0-based byte-position within the receivers byteArray
	where the instVar with index anInteger is located."

	^ self headerSize + ((anInteger - 1) * self wordSize)
! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:33'!
bufferType
	^ 5! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 12/2/2004 12:35'!
createObjectUsing: aMaObjectSerializer
	| answer |
	answer _ (self ensureClassUsing: aMaObjectSerializer) basicNew: self objectInstSize.
	1 to: self objectInstSize do:
		[ : x |
		answer
			basicAt: x
			put: (self wordAt: x) ].
	^ answer! !

!MaVariableWordBuffer methodsFor: 'testing' stamp: 'cmm 2/8/2005 18:01'!
isPointers

	^ false! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:12'!
maInstVarAt: logicalPosition

	^ self wordAt: logicalPosition! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:12'!
maInstVarAt: logicalPosition put: anInteger

	^ self
		wordAt: logicalPosition
		put: anInteger! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 12:41'!
numberToStoreFor: anInteger using: aMaObjectSerializer

	^ anInteger! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/21/2004 19:19'!
populateBodyFor: storageObject using: aMaObjectSerializer

	1
		to: storageObject maInstSize
		do:
			[ :index |
			self
				wordAt: index
				put: (storageObject instVarAt: index) ]! !

!MaVariableWordBuffer methodsFor: 'printing' stamp: 'cmm 11/19/2004 17:28'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(words)
		on: aStream! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 11:08'!
slotSize

	^ 4! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:10'!
wordAt: logicalPosition

	^ self 
		uint: 32
		at: (self bufferPositionOfInstVarAt: logicalPosition)! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:09'!
wordAt: logicalPosition put: anInteger

	self
		uint: 32
		at: (self bufferPositionOfInstVarAt: logicalPosition)
		put: anInteger! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:06'!
wordSize
	^ 4! !

!MaVariableWordBuffer methodsFor: 'printing' stamp: 'cmm 12/2/2004 12:35'!
words
	"This is intended for printing only."
	self objectInstSize isInteger ifFalse: [ ^ '** invalid **' ].
	^ (1 to: self objectInstSize) collect: [ : index | self maInstVarAt: index ]! !

MaObject subclass: #MaObjectSerializer
	instanceVariableNames: 'oidManager classIdManager preMadeObjectBuffers graphBuffer createProxyBlock traversalStrategy amBusy truncatedObjects preferences'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-API'!

!MaObjectSerializer class methodsFor: 'creation' stamp: 'cmm 10/15/2002 22:15'!
new

	^self new: 1000
! !

!MaObjectSerializer class methodsFor: 'creation' stamp: ''!
new: anInteger

	^super new optimumByteArraySize: anInteger
! !

!MaObjectSerializer class methodsFor: 'debugging' stamp: 'cmm 10/15/2004 12:54'!
testMaterialize: anObject

	| s1 graphBuffer |

	s1 _ self new.
	graphBuffer _ s1 serializeGraph: anObject.
	^self new
		classDefinitionsByteArray: s1 classDefinitionsByteArray;
		materializeGraph: graphBuffer byteArray copy! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 3/28/2005 14:01'!
append: anObject
	"Append only anObject to the receiver.  However, in the case where anObject is stored via a storage-object (see #maAsStorageObject), the entire graph of the storage object must be stored."

	| storageObject |
	storageObject _ anObject maAsStorageObject.
	anObject maWantsPreSerialization ifTrue: [ self preSerialize: storageObject ].
	(storageObject ~~ anObject and: [ storageObject maSerializationClass isPointers "(because bytes can already be stored as-is)" ])
		ifTrue:
			[ "This is a first-class storage object, so serialize it into a ByteArray and make *that* the storage object."
			storageObject _ (self copyWithNewBuffer serializeGraph: storageObject) trimmedByteArray ].
	self graphBuffer increaseBufferSizeBy:
		(self
			bufferFor: anObject
			storageObject: storageObject
			startingAt: self graphBuffer bufferSize)
				physicalSize.
	"Since the need is so scarce anyway, if you order pre-serialization, you get post too."
	anObject maWantsPreSerialization ifTrue: [ self postSerialize: storageObject ]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/29/2004 17:12'!
appendGraph: anObject do: oneArgBlock
	"Answer a MaSerializedObjectBuffer containing anObject and all objects
	it can reach, serialized into aByteArray."

	self beBusy.
	anObject
		maGraphDo:
			[ : path : parent : index |
			(path last
				maShouldAppendWithPath: path
				parent: parent
				index: index)
				ifTrue:
					[ self append: path last.
					oneArgBlock value: path last ] ]
		using: self traversalStrategy.
	self beBored.
	^ self graphBuffer! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/29/2002 23:22'!
beBored

	amBusy _ false
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/29/2002 23:33'!
beBusy

	amBusy _ true
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/21/2004 22:38'!
bufferFor: anObject storageObject: storageObject startingAt: anInteger

	| buffer |
	buffer _ (storageObject maSelectPreMadeObjectBufferFrom: self)
		startPos: anInteger ;
		ensureSpaceFor: storageObject.
	buffer byteArray == self byteArray
		ifFalse:
			[ "aByteArray must not have been big enough.."
			self byteArray: buffer byteArray ].
	buffer
		populateHeaderFor: anObject
		storageObject: storageObject
		using: self.
	buffer
		populateBodyFor: storageObject
		using: self.
	^ buffer! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
byteArray

	^self graphBuffer byteArray
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
byteArray: aByteArray

	self graphBuffer byteArray: aByteArray.
	preMadeObjectBuffers do: [ :each | each byteArray: aByteArray ]
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 6/8/2004 21:14'!
classDefinitionsByteArray
	"Answer a ByteArray that can be used to reinitialize a new instance of the receiver so that it can materialize the objects it has serialized."

	^ (
self copyWithNewBuffer serializeGraph: self classIdManager classDefinitionsById) trimmedByteArray! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 6/8/2004 22:09'!
classDefinitionsByteArray: aByteArray
	"Initialize the receiver with aByteArray that materializes to my classDefinitions.  These are the classDefinitions used to work with objects that were being used when the user saved off the byteArray by calling the getter, #classDefinitionsByteArray."

	self classDefinitions: (self materializeGraph: aByteArray)! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 5/23/2004 22:18'!
classDefinitionsOid

	^self oidFor: self classIdManager classDefinitionsById! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 4/10/2005 18:56'!
classFor: anObject 

	^ anObject maSerializationClass! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
classIdManager

	^classIdManager
! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 1/27/2005 23:59'!
classIdManager: aMaClassIdManager

	classIdManager _ aMaClassIdManager.
	self setUpClassDefinitionPostMaterialization! !

!MaObjectSerializer methodsFor: 'copying' stamp: 'cmm 3/24/2005 11:59'!
copyWithNewBuffer

	^ self copy
		postCopyWithNewBuffer ;
		yourself! !

!MaObjectSerializer methodsFor: 'copying' stamp: 'cmm 3/24/2005 11:58'!
copyWithNewOidSpace
	"Answer a new instance of the me that shares my class-ids, but not the oids."
	
	^ self copyWithNewBuffer
		postCopyWithNewOidSpace ;
		yourself! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 1/20/2003 22:26'!
finalizeOids

	oidManager finalizeOids! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
graphBuffer

	^graphBuffer
! !

!MaObjectSerializer methodsFor: 'building' stamp: ''!
graphBuffer: aMaSerializedGraphBuffer

	graphBuffer _ aMaSerializedGraphBuffer
! !

!MaObjectSerializer methodsFor: 'event handling' stamp: 'cmm 12/12/2004 18:54'!
handleClassModification: aModifiedClassDefinitionEvent

	aModifiedClassDefinitionEvent isModified ifFalse: [ ^ self ].
	aModifiedClassDefinitionEvent item isMeta ifTrue: [ ^ self ].
	oidManager
		handleClassModification: aModifiedClassDefinitionEvent item
		using: self.
	classIdManager
		handleClassModification: aModifiedClassDefinitionEvent item
		using: self! !

!MaObjectSerializer methodsFor: 'testing' stamp: 'cmm 7/17/2002 22:49'!
hasOidFor: anObject

	^oidManager hasOidFor: anObject! !

!MaObjectSerializer methodsFor: 'copying' stamp: 'cmm 3/24/2005 11:51'!
independentCopy
	"Answer a completely independent copy of the receiver.  This will probably mostly be used during debugging."

	^ self copy postIndependentCopy! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 2/1/2005 15:27'!
initialize

	super initialize.
	preferences _ MaObjectSerializerPreferences new.
	self
		oidManager: MaOidManager new;
		classIdManager: MaClassIdManager new;
		initializeTraversalStrategy;
		toCreateProxies: [ :oid | MaObjectSerializationUserError signal: 'No createProxyBlock specified.  See MaObjectSerializer>>toCreateProxies:' ].
	self graphBuffer: (MaSerializedGraphBuffer new: 50).
	self initializePreMadeObjectBuffers.
	self beBored.
	truncatedObjects _ WeakIdentityKeyDictionary new  "want a WeakIdentitySet..".
	self setUpPreAndPostProcessing! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 10/21/2004 12:53'!
initializePreMadeObjectBuffers

	preMadeObjectBuffers _ MaObjectBuffer bufferClasses collect:
		[ :each |
		each
			byteArray: self byteArray
			startPos: 0 ]
! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 11/29/2004 11:04'!
initializeTraversalStrategy
	traversalStrategy _
		MaObjectGraphTraversalStrategy new
			traverseWhen:
				[ : path : parent : indexInteger | 
				path last
					maShouldTraverseWithPath: path
					parent: parent
					index: indexInteger ]! !

!MaObjectSerializer methodsFor: 'testing' stamp: 'cmm 6/5/2004 17:26'!
isTruncated: anObject
	"A truncated object is one that has been read, but the in-image definition did not have a place for one of its inst vars.  This is useful for then detecting if the user tries to write that object back out to warn him that he will lose data."

	^ truncatedObjects includesKey: anObject! !

!MaObjectSerializer methodsFor: 'materializing' stamp: 'cmm 10/9/2004 23:58'!
materializeGraph: aByteArray

	^self
		materializeGraph: aByteArray
		do: [ : eachObject : eachBuffer | "do nothing" ]
! !

!MaObjectSerializer methodsFor: 'materializing' stamp: 'cmm 1/30/2005 20:47'!
materializeGraph: aByteArray do: twoArgBlock
	"Answer a fully-formed object from aByteArray of aMaSerializedGraphBuffer.  If buffers are missing to complete the full-graph, I will substitute with proxy's based on the block specified by toCreateProxies:."

	"Guard against stepping on my own buffers if I'm busy serializing or materializing already."
	^ amBusy
		ifTrue:
			[ self copyWithNewBuffer
				byteArray: aByteArray;
				materializeGraphDo: twoArgBlock ]
		ifFalse:
			[ self
				byteArray: aByteArray;
				materializeGraphDo: twoArgBlock ]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 2/3/2005 11:18'!
materializeGraphDo: twoArgBlock
	"Materialize as much as the object in the receivers byteArray as possible.  For each object *materialized*, value twoArgBlock [ : eachObject : eachBuffer | ].  twoArgBlock is not valued for objects encountered in the materialized graph if they were already present in the receivers oidManager, that way we know when objects are exactly materialized."

	| skeletons rootObject needToRehash |
	needToRehash _ false.
	skeletons _ OrderedCollection new: 48.
	rootObject _ nil.
	self beBusy.
	self graphBuffer buffersDo:
		[ : each | | object |
		object _
			self
				objectWithOid: each oid
				ifFound:
					[ : foundObj |
					foundObj maIsMutatingProxy "true when materializing a proxy"
						ifTrue: [ skeletons add: (self newSkeletonFor: each fromProxy: foundObj) -> each copyWithSameBuffer ].
					foundObj ]
				ifAbsent:
					[ | newObject |
					skeletons add: (Association key: (newObject _ self newSkeletonFor: each fromProxy: nil) value: each copyWithSameBuffer).
					newObject ].
		rootObject ifNil: [ rootObject _ object ] ].
	"Do not merge these do's.."
	skeletons do:
		[ : eachAssociation |  | eachObject eachBuffer |
		eachObject _ eachAssociation key.
		eachBuffer _ eachAssociation value.
		(eachObject maIsHashedCollection and: [ eachObject notEmpty ]) ifTrue: [ needToRehash _ true ].
		eachBuffer
			establishReferencesFrom: eachObject
			using: self ].
	needToRehash ifTrue:
		[ skeletons do:
			[ : eachAssociation | 
			eachAssociation key maIsHashedCollection ifTrue: [ eachAssociation key rehash ] ] ].
	skeletons do:
		[ : eachAssociation |  | eachFullyFormedObject eachBuffer |
		eachFullyFormedObject _ eachAssociation key.  eachBuffer _ eachAssociation value.
		eachFullyFormedObject maWantsPostMaterialization ifTrue: [ self postMaterialize: eachFullyFormedObject ].
		twoArgBlock
			value: eachFullyFormedObject
			value: eachBuffer "up to user to copy this if they need to." ].
	self beBored.
	^ rootObject! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 1/18/2005 16:09'!
newSkeletonFor: aMaObjectBuffer fromProxy: aMaMutatingProxy

	| skel |
	skel _ aMaObjectBuffer createObjectUsing: self.
	aMaMutatingProxy ifNotNil: [ aMaMutatingProxy becomeForward: skel copyHash: false ].
	self
		oidOf: skel
		is: aMaObjectBuffer oid.
	^ skel! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 3/20/2003 21:55'!
objectWithOid: anInteger ifAbsent: aBlock

	^oidManager
		objectWithOid: anInteger
		ifAbsent: aBlock
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 3/20/2003 21:54'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^oidManager
		objectWithOid: anInteger
		ifFound: oneArgBlock
		ifAbsent: aBlock
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 12/29/2004 14:26'!
objectsDo: oneArgBlock
	oidManager objectsDo: oneArgBlock! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 4/20/2003 22:18'!
oidCount
	"Answers the number of objects that have oids."

	^oidManager oidCount! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 3/20/2003 21:54'!
oidFor: anObject

	^oidManager oidFor: anObject
! !

!MaObjectSerializer methodsFor: 'building' stamp: ''!
oidManager: aMaOidManager

	oidManager _ aMaOidManager
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 6/23/2004 17:41'!
oidOf: anObject is: anInteger

	oidManager
		oidOf: anObject
		is: anInteger! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 12/29/2002 16:49'!
optimumByteArraySize: anInteger

	self byteArray: (ByteArray new: anInteger).
	self resetByteArray! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 3/24/2005 14:20'!
postCopyWithNewBuffer

	graphBuffer _ MaSerializedGraphBuffer new: 1000.
	self
		initializePreMadeObjectBuffers;
		resetByteArray;
		beBored! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 3/28/2005 22:24'!
postCopyWithNewOidSpace
	
	self oidManager: oidManager species new! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 3/24/2005 11:49'!
postIndependentCopy
	"Answer a completely independent copy of the receiver.  This will probably mostly be used during debugging."

	self 
		oidManager: oidManager independentCopy;
		classIdManager: self classIdManager independentCopy;
		resetByteArray.
	graphBuffer _ graphBuffer copy.
	traversalStrategy _ traversalStrategy copy! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 4/10/2005 18:00'!
postMaterialize: anObject 
	"maPostMaterialize could be useful for when you don't necessarily require serialization, but needed so that it *can* be used, if desired."

	(anObject respondsTo: #maPostMaterialize) 
		ifTrue: [anObject maPostMaterialize].
	anObject maOriginalClass withAllSuperclassesDo: 
			[:eachClass | 
			preferences postMaterializers 
				maAt: eachClass name
				ifPresent: 
					[:valuators | 
					valuators do: [:each | each valueWithArguments: { 
										anObject}]]
				ifAbsent: 
					["do nothing"

					]]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 4/10/2005 18:00'!
postSerialize: anObject 
	"maPostSerialize could be useful for when you don't necessarily require serialization, but needed so that it *can* be used, if desired."

	(anObject respondsTo: #maPostSerialize) ifTrue: [anObject maPostSerialize].
	anObject maOriginalClass withAllSuperclassesDo: 
			[:eachClass | 
			preferences postSerializers 
				maAt: eachClass name
				ifPresent: [:valuators | valuators do: [:each | each value: anObject]]
				ifAbsent: 
					["do nothing"

					]]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:42'!
preMadeByteObjectBuffer

	^ self preMadeObjectBufferAt: 1! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:43'!
preMadeClassObjectBuffer

	^ self preMadeObjectBufferAt: 4! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:43'!
preMadeFixedObjectBuffer

	^ self preMadeObjectBufferAt: 3! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:42'!
preMadeObjectBufferAt: bufferTypeInteger

	^ preMadeObjectBuffers at: bufferTypeInteger! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:43'!
preMadeVariableObjectBuffer

	^ self preMadeObjectBufferAt: 2! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/19/2004 15:27'!
preMadeVariableWordBuffer

	^ self preMadeObjectBufferAt: 5! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 4/10/2005 18:00'!
preSerialize: anObject 
	"maPreserialize could be useful for when you don't necessarily require serialization, but needed so that it *can* be used, if desired."

	(anObject respondsTo: #maPreserialize) ifTrue: [anObject maPreserialize].
	anObject maOriginalClass withAllSuperclassesDo: 
			[:eachClass | 
			preferences preSerializers 
				maAt: eachClass name
				ifPresent: 
					[:valuators | 
					valuators do: [:each | each valueWithArguments: { 
										anObject}]]
				ifAbsent: 
					["do nothing"

					]]! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 11/26/2004 09:46'!
preferences
	^ preferences! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 4/23/2003 23:16'!
proxyFor: oid

	^oidManager retainIdentityOfProxy: (createProxyBlock value: oid)
! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 6/5/2004 17:27'!
recordTruncatedObject: anObject
	"A truncated object is one that has been read, but the in-image definition did not have a place for one of its inst vars.  This is useful for then detecting if the user tries to write that object back out to warn him that he will lose data.  See also isTruncated:."

	truncatedObjects at: anObject put: nil! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 12/29/2004 17:30'!
rehashOids

	oidManager rehashOids! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 11/26/2004 09:43'!
resetByteArray
	"Ensure my preMade buffers share the same byteArray as my graphBuffer (a performance optimization) and set my size to 0 objects."
	preMadeObjectBuffers first byteArray ~~ self byteArray
		ifTrue: [ preMadeObjectBuffers do: [ :each | each byteArray: self byteArray ] ].
	self graphBuffer resetBufferSize! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 3/20/2003 21:54'!
resetOidManager
	"If receiving a byteArray from another serializer, this method should
	be invoked prior to materializing here so cached oids in the oidManager
	that may not match the objects that were serialized by the other
	serializer.  MaClientServerOidManager avoids the need to do this, once connected."

	oidManager reset
! !

!MaObjectSerializer methodsFor: 'serializing' stamp: ''!
serializeGraph: anObject
	"Answer a MaSerializedGraphBuffer containing anObject and all objects
	it can reach, serialized into aByteArray."

	^self
		serializeGraph: anObject
		do: [ :each | nil ]
! !

!MaObjectSerializer methodsFor: 'serializing' stamp: 'cmm 11/16/2004 23:39'!
serializeGraph: anObject do: oneArgBlock
	"Answer a MaSerializedGraphBuffer containing anObject and all objects it can reach, serialized into aByteArray."

	^ self copyWithNewBuffer
		resetByteArray;
		appendGraph: anObject
		do: oneArgBlock! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 2/6/2005 12:36'!
setUpClassDefinitionPostMaterialization

	preferences
		afterMaterializingAny: #MaClassDefinition
		do:
			(MessageSend
				receiver: classIdManager
				selector: #addClassDefinition:)! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 3/13/2005 18:02'!
setUpPreAndPostProcessing
	"Initiailize the pre and post-materializers for classes that come with standard Squeak.  Base Squeak uses one of two methods for serializing objects; ReferenceStream and ImageSegments.  MaObjectSerialization more-closely resembles ReferenceStream.  While the setup for these processors is based on the behavior in those other two frameworks, there are bound to be some minor differences."

	self setUpClassDefinitionPostMaterialization.

	preferences
		beforeSerializingAny: #Color
		do: [ : aColor | aColor flushCache "saves space" ].

"preferences
	beforeSerializingAny: #Form
	do: [ : aForm | aForm hibernate ].
preferences
	afterSerializingAny: #Form
	do: [ : aForm | aForm unhibernate ].
preferences
	afterMaterializingAny: #Form
	do: [ : aForm | aForm unhibernate ]."
"preferences
	beforeSerializingAny: #ColorForm
	do: [ : aColorForm | aColorForm clearColormapCache ]."

	preferences
		beforeSerializingAny: #PasteUpMorph
		do:
			[ : aPasteUpMorph | aPasteUpMorph prepareToBeSaved.  "Amen" ].
"preferences
	afterSerializingAny: #ScriptEditorMorph
	do: [ : aScriptEditorMorph | aScriptEditorMorph class = BooleanScriptEditor ifFalse: [ aScriptEditorMorph unhibernate ] ].
preferences
	afterMaterializingAny: #ScriptEditorMorph
	do: [ : aScriptEditorMorph | aScriptEditorMorph class = BooleanScriptEditor ifFalse: [ aScriptEditorMorph unhibernate ] ]."
	preferences
		beforeSerializingAny: #TTCFont
		do: [ : aTTCFont | aTTCFont flushCache ].

"preferences
		beforeSerializingAny: #Wonderland
		do: [ : aWonderland | aWonderland prepareToBeSaved ].
preferences
	beforeSerializingAny: #ViewerFlapTab
	do: [ : aViewFlapTab | aViewFlapTab hibernate ]."
self maMarked: 'dev'.
"You've got this commented out because it changes the shape of the object while you're serializing it, which ends up causing the graphBuffer to not be #isWhole (which causes problems on materialization).
Do we need this?  It appears that Project>>exportSegmentWithChangeSet:  fileName:  directory: calls it at the end.  Also, Project>>exportSegmentWithCatagories: classes: fileName: directory:"
"preferences
	afterSerializingAny: #ViewerFlapTab
	do: [ : aViewerFlapTab | aViewerFlapTab unhibernate ].
preferences
	afterMaterializingAny: #ViewerFlapTab
	do: [ : aViewerFlapTab | aViewerFlapTab unhibernate ]."
	preferences
		beforeSerializingAny: #Project
		do:
			[ : aProject |  | world |
			world _ aProject world.
			aProject world setProperty: #optimumExtentFromAuthor toValue: aProject world extent.  "As suggested by Project>>#storeOnServerAssumingNameValid".
			"The following is from Project>>#exportSegmentWithChangeSet:fileName:directory:"
			Utilities emptyScrapsBook.
			world currentHand pasteBuffer: nil.	  "don't write the paste buffer."
			world currentHand mouseOverHandler initialize.	  "forget about any references here"
				"Display checkCurrentHandForObjectToPaste."
			Command initialize.
			world clearCommandHistory.
			world fullReleaseCachedState; releaseViewers. 
			world cleanseStepList.
			world releaseSqueakPages.
			ScriptEditorMorph writingUniversalTiles: (aProject projectParameterAt: #universalTiles ifAbsent: [false]) ].
	preferences
		afterMaterializingAny: #Project
		do:
			[ : aProject |
			aProject setParent: Project current.
			aProject world beWorldForProject: aProject. "sets aProject's worldState"
			"This behavior suggested by ImageSegment>>#comeFullyUpOnReload:"
			aProject ensureChangeSetNameUnique.
			Project addingProject: aProject.
			aProject restoreReferences.
			self maMarked: 'dev'.  "need to restore dependents??"
			ScriptEditorMorph writingUniversalTiles: 
				((aProject projectPreferenceAt: #universalTiles) ifNil: [false]) ].
"preferences
	afterMaterializingAny: #WorldState
	do:
		[ : aWorldState |
		aWorldState
			convertStepList ;
			convertAlarms ]."! !

!MaObjectSerializer methodsFor: 'testing' stamp: 'cmm 12/29/2004 14:27'!
sharesAnyObjectsWith: anotherMaObjectSerializer
	anotherMaObjectSerializer objectsDo:
		[ : each |
		(self hasOidFor: each) ifTrue: [ ^ true ] ].
	self objectsDo:
		[ : each |
		(anotherMaObjectSerializer hasOidFor: each) ifTrue: [ ^ true ] ].
	^ false! !

!MaObjectSerializer methodsFor: 'building' stamp: ''!
toCreateProxies: oneArgBlock

	createProxyBlock _ oneArgBlock
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
traversalStrategy

	^traversalStrategy
! !

MaObject subclass: #MaObjectSerializerPreferences
	instanceVariableNames: 'preSerializers postSerializers postMaterializers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-API'!

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/11/2005 11:17'!
afterMaterializingAny: className do: oneArgValuator
	"Set up preference for materializing instances of the class named className by sending oneArgValuator.  The first argument is the object being serialized, the second is the serializer (aMaObjectSerializer) doing the serialization."

	| valuators |
	self
		validate: className
		has: #maWantsPostMaterialization.
	valuators _ 
		(postMaterializers
			at: className
			ifAbsentPut: [ OrderedCollection new ]).
	(valuators includes: oneArgValuator) ifFalse: [ valuators add: oneArgValuator ]! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/11/2005 11:17'!
afterSerializingAny: className do: oneArgValuator
	"Set up preference for serializing instances of class named className by sending oneArgValuator.  The first argument is the object being serialized, the second is the serializer (aMaObjectSerializer) doing the serialization."

	| valuators |
	self
		validate: className
		has: #maWantsPreSerialization.
	valuators _ postSerializers
		at: className
		ifAbsentPut: [ OrderedCollection new ].
	(valuators includes: oneArgValuator) ifFalse: [ valuators add: oneArgValuator ]! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/11/2005 11:17'!
beforeSerializingAny: className do: oneArgValuator
	"Set up preference for serializing instances of aClass by sending oneArgValuator.  The first argument is the object being serialized, the second is the serializer (aMaObjectSerializer) doing the serialization.
	Note, only do this if aClass is present."

	| valuators |
	self
		validate: className
		has: #maWantsPreSerialization.
	valuators _ 
		preSerializers
			at: className
			ifAbsentPut: [ OrderedCollection new ].
	(valuators includes: oneArgValuator) ifFalse: [ valuators add: oneArgValuator ]! !

!MaObjectSerializerPreferences methodsFor: 'initializing' stamp: 'cmm 11/28/2004 19:22'!
initialize
	super initialize.
	preSerializers _ Dictionary new.
	postSerializers _ Dictionary new.
	postMaterializers _ Dictionary new! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/26/2004 10:17'!
postMaterializers
	^ postMaterializers! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/28/2004 17:12'!
postSerializers
	^ postSerializers! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/26/2004 10:17'!
preSerializers
	^ preSerializers! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/3/2005 22:54'!
releasePostMaterializationFor: className
	"Remove all post-materialization behaviors for the class named className."
	postMaterializers
		removeKey: className
		ifAbsent: [ "ok" ]! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/3/2005 22:55'!
releasePostSerializationFor: className
	"Remove all post-materialization behaviors for the class named className."
	postSerializers
		removeKey: className
		ifAbsent: [ "ok" ]! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/3/2005 22:51'!
releasePreserializationFor: className
	"Remove all preserialization behaviors for the Class named className."
	preSerializers
		removeKey: className
		ifAbsent: [ "ok" ]! !

!MaObjectSerializerPreferences methodsFor: 'validate' stamp: 'cmm 2/11/2005 12:59'!
validate: className has: selector

	(Smalltalk hasClassNamed: className) ifFalse: [ "No validation needed" ^ true ].
	((Smalltalk at: className) basicNew perform: selector)
		ifFalse:
			[ MaObjectSerializationUserError signal: 'Need to implement ', selector, ' on ', className ]! !

MaObject subclass: #MaOidCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaOidCalculator commentStamp: 'cmm 12/1/2004 11:04' prior: 0!
The oid ranges are as follows:

The range from (0 to: SmallInteger maxVal - SmallInteger minVal) are reserved for:  user objects, the non-integral atomics including 65536 characters and space for 2000000 new-object oids (bigger than any transaction should ever be!!).  We should allow a few thousand for future-use as well.

SmallInteger minVal actually starts at the oid with the value SmallInteger maxVal + 1.  Thus, SmallInteger maxVal has the oid

We start at the bottom so user-objects are contiguous above 
 
  a   n u m b e r   l i n e
|<--- SmallInteger range -------------->|< - - - - - -  LargeInteger range - - - - - - - - - ->|
atomics, chars, new objects, future  |    u s e r  o b j e c t s   | Floats | SmallIntegers  |

0
	nil
1
	false
2
	true
3 to: 65538
	DB character-set (only SB currently supported)
65539
	indicate an unused slot in a MaHashIndex
65540 to: 66540
	future use?
66541 to: 66541 + 2000000
	new-object oids
2066542 to: 18446744067266100672 (oid for smallest float - 1)
	user objects
18446744067266100673 to: 18446744071561067967
	32-bit IEEE floats
18446744071561067968 to: 18446744073708551615
	SmallIntegers
!

!MaOidCalculator class methodsFor: 'special' stamp: 'cmm 8/6/2002 23:39'!
firstCharacterOid

	^3! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 8/8/2002 23:01'!
floatFromOid: anInteger

	^Float fromIEEE32Bit: anInteger - self oidForSmallestFloat! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/6/2002 23:52'!
integerFromOid: oidInteger

	^oidInteger - self oidForZero! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 8/8/2002 23:36'!
isOidForFloat: oidInteger

	^oidInteger
		between: self oidForSmallestFloat
		and:  18446744071561067967  "self oidForSmallestOptimizedInteger - 1"! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/8/2002 22:28'!
isOidForOptimizedInteger: oidInteger

	^oidInteger
		between: self oidForSmallestOptimizedInteger  "self oidForZero + SmallInteger minVal"
		and: 18446744073708551615  "self oidForZero + SmallInteger maxVal"! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/6/2002 23:44'!
isOptimizedInteger: anInteger

	^anInteger class = SmallInteger! !

!MaOidCalculator class methodsFor: 'special' stamp: 'cmm 8/6/2002 23:39'!
lastCharacterOid

	"^self firstCharacterOid + 65535"   "DBCS"
	^65538! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 9/1/2002 22:54'!
newOidMinimum

	^66541! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 8/8/2002 22:57'!
objectWithOid: anInteger ifNone: aBlock

	anInteger == self oidForNil ifTrue: [ ^nil ].
	anInteger == self oidForFalse ifTrue: [ ^false ].
	anInteger == self oidForTrue ifTrue: [ ^true ].
	(self isOidForFloat: anInteger)
		ifTrue:
			[ ^self floatFromOid: anInteger ].
	(self isOidForOptimizedInteger: anInteger)
		ifTrue:
			[ ^self integerFromOid: anInteger ].
	(anInteger
		between: self firstCharacterOid
		and: self lastCharacterOid)
			ifTrue:
				[ ^Character value: anInteger - self firstCharacterOid ].
	^aBlock value! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 8/6/2002 23:40'!
oidForCharacter: aCharacter

	^self firstCharacterOid + aCharacter asciiValue! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 8/6/2002 23:41'!
oidForFalse

	^1! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 8/8/2002 23:06'!
oidForFloat: aFloat

	^aFloat asIEEE32BitWord + self oidForSmallestFloat! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/6/2002 23:51'!
oidForInteger: anInteger

	^anInteger + self oidForZero! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 8/6/2002 23:37'!
oidForNil

	^0! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 8/8/2002 23:02'!
oidForSmallestFloat

	^18446744067266100673  "self oidForSmallestOptimizedInteger - 16rFFFFFFFF"! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/8/2002 22:29'!
oidForSmallestOptimizedInteger

	^18446744071561067968! !

!MaOidCalculator class methodsFor: 'oids' stamp: 'cmm 8/6/2002 23:41'!
oidForTrue

	^2! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/6/2002 23:54'!
oidForZero

	"^16rFFFFFFFFFFFFFFFF - SmallInteger maxVal - 1000000"
	^ 18446744072634809792! !

!MaOidCalculator class methodsFor: 'special' stamp: 'cmm 8/6/2002 23:38'!
specialValueForUnusedHashIndexEntry

	^3! !

MaObject subclass: #MaOidManager
	instanceVariableNames: 'objects oids nextOid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaOidManager methodsFor: 'actions' stamp: 'cmm 1/20/2003 22:28'!
finalizeOids

	oids finalizeValues! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 8/11/2002 18:28'!
getNextOid

	^nextOid _ nextOid + 1! !

!MaOidManager methodsFor: 'event handling' stamp: 'cmm 6/24/2004 11:59'!
handleClassModification: aClass using: aMaObjectSerializer
	"optional subclass responsibility"! !

!MaOidManager methodsFor: 'testing' stamp: 'cmm 7/17/2002 22:51'!
hasOidFor: anObject

	^oids includesKey: anObject! !

!MaOidManager methodsFor: 'copying' stamp: 'cmm 3/24/2005 11:36'!
independentCopy

	^ self copy postIndependentCopy! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 1/20/2003 21:12'!
initialize

	super initialize.
	self
		reset;
		resetNextOid! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 12/27/2002 16:03'!
objectWithOid: anInteger ifAbsent: aBlock

	^self
		objectWithOid: anInteger
		ifFound: [ :foundObj | foundObj ]
		ifAbsent: aBlock! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 12/25/2002 12:15'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^MaOidCalculator
		objectWithOid: anInteger
		ifNone:
			[ objects
				maAt: anInteger
				ifPresent:
					[ :obj |
					obj   "oid key marked to be cleaned"
						ifNil: [ aBlock value ]
						ifNotNil: [ oneArgBlock value: obj ] ]
				ifAbsent: [ aBlock value ] ]! !

!MaOidManager methodsFor: 'actions' stamp: 'cmm 12/29/2004 13:54'!
objectsDo: oneArgBlock

	objects do: oneArgBlock! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 4/20/2003 22:18'!
oidCount

	^oids size! !

!MaOidManager methodsFor: 'accessing' stamp: ''!
oidFor: anObject

	^self
		oidFor: anObject
		ifAbsent:
			[ self
				oidOf: anObject
				is: self getNextOid ]
! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 1/18/2005 16:12'!
oidFor: anObject ifAbsent: aBlock

	anObject maIsMutatingProxy ifTrue: [ ^ anObject mutatingProxyOid ].
	^anObject maRequiresOwnBuffer
		ifTrue:
			[ oids
				maAt: anObject
				ifPresent: [ : oid | oid ifNil: [ aBlock value ] ifNotNil: [ oid ] ]
				ifAbsent: aBlock ]
		ifFalse:
			[ anObject maOid ]! !

!MaOidManager methodsFor: 'building' stamp: 'cmm 5/8/2003 13:57'!
oidOf: anObject is: anInteger

	objects size > (oids size * 2) ifTrue: [ self removeGarbageCollectedObjectEntries ].
	objects
		at: anInteger
		put: anObject.
	^oids
		at: anObject
		put: anInteger! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 3/24/2005 11:36'!
postIndependentCopy

	objects _ objects copy.
	oids _ oids copy.
	self resetNextOid! !

!MaOidManager methodsFor: 'actions' stamp: 'cmm 12/29/2004 17:29'!
rehashOids

	oids rehash! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 3/20/2003 12:58'!
removeGarbageCollectedObjectEntries

	objects _ objects reject: [ :each | each isNil ]! !

!MaOidManager methodsFor: 'actions' stamp: 'cmm 12/12/2002 22:34'!
reset
	"When dealing with other serializers, their oid managers have different ideas on what
	oids of objects should be.  That's why we clear out all the oids from the previous serialization
	activity."

	oids _ MaWeakIdentityKeyDictionary new.
	objects _ MaWeakValueDictionary new
! !

!MaOidManager methodsFor: 'private' stamp: ''!
resetNextOid

	nextOid _ MaOidCalculator newOidMinimum
! !

!MaOidManager methodsFor: 'building' stamp: 'cmm 1/18/2005 16:12'!
retainIdentityOfProxy: aMaMutatingProxy

	^ objects
		at: aMaMutatingProxy mutatingProxyOid
		put: aMaMutatingProxy! !

MaObject subclass: #MaSerializedGraphBuffer
	instanceVariableNames: 'byteArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaSerializedGraphBuffer commentStamp: '<historical>' prior: 0!
Header:

	total physical size of this buffer.  Necessary because we otherwise have no
	way of knowing where the actual end of the buffer is.
!

!MaSerializedGraphBuffer class methodsFor: 'private accessing' stamp: 'cmm 9/22/2002 23:52'!
headerSize
	"header only has 32-bit integer representing the physicalSize of my byteArray that holds the entire serialized graph."

	^4! !

!MaSerializedGraphBuffer class methodsFor: 'creation' stamp: ''!
new: anInteger

	^self new resetByteArray: (ByteArray new: anInteger)
! !

!MaSerializedGraphBuffer methodsFor: 'private actions' stamp: 'cmm 10/21/2004 12:52'!
bufferPositionsDo: oneArgBlock

	"Value oneArgBlock with the value of the starting position of each
	buffer in the receiver."

	| pos end |

	pos _ self headerSize.
	end _ self bufferSize - 1.
	[ pos <= end ] whileTrue:
		[ oneArgBlock value: pos.
		pos _
			pos +
				(byteArray 
					maUint: 24
					at: pos + MaObjectBuffer bufferPositionOfPhysicalSize) ]
! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 4/3/2003 00:10'!
bufferSize

	^byteArray 
		maUint: 32
		at: 0
! !

!MaSerializedGraphBuffer methodsFor: 'private building' stamp: 'cmm 4/3/2003 00:11'!
bufferSize: anInteger

	byteArray
		maUint: 32
		at: 0
		put: anInteger
! !

!MaSerializedGraphBuffer methodsFor: 'private accessing' stamp: 'cmm 10/21/2004 12:52'!
bufferTypeAt: startPositionOfObjectBuffer

	^byteArray
		maUint: 8
		at: startPositionOfObjectBuffer + MaObjectBuffer bufferPositionOfBufferType! !

!MaSerializedGraphBuffer methodsFor: 'creation' stamp: ''!
buffers

	| coll |

	coll _ OrderedCollection new.
	self buffersDo: [ :each | coll add: each copy ].
	^coll
! !

!MaSerializedGraphBuffer methodsFor: 'actions' stamp: 'cmm 4/3/2003 00:11'!
buffersDo: oneArgBlock
	"Value oneArgBlock with each ObjectBuffer in the
	receiver.  There is one ObjectBuffer for each object in the graph that
	the receiver represents."

	| preMadeBuffers |
	preMadeBuffers _ self newPremadeBuffers.
	self bufferPositionsDo:
		[ :eachPosition | | buffer |
		buffer _ (preMadeBuffers at: (self bufferTypeAt: eachPosition)).
		buffer
			byteArray: byteArray;
			startPos: eachPosition.
		oneArgBlock value: buffer ]! !

!MaSerializedGraphBuffer methodsFor: 'debugging' stamp: 'cmm 3/28/2005 21:54'!
buffersMissingFromWhole
	"Answer whether I have all the object buffers needed to reconstitute my entire graph."

	| oids missing |
	missing _ OrderedCollection new.
	oids _ (self buffers collect: [ : each | each oid ]) asSet.
	self buffers do:
		[ : each |
		each species = MaFixedObjectBuffer
			ifTrue:
				[ each oids do:
					[ : eachOid | 
					((MaOidCalculator isOidForOptimizedObject: eachOid) not
					and: [ (oids includes: eachOid) not ]) ifTrue: [ missing add: eachOid->each copyWithSameBuffer ] ] ] ].
	^ missing! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: ''!
byteArray
	"One ByteArray holds the entire graph of objects."

	^byteArray
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: ''!
byteArray: aByteArray

	byteArray _ aByteArray
! !

!MaSerializedGraphBuffer methodsFor: 'private creation' stamp: 'cmm 3/24/2005 12:49'!
copy

	^ super copy postCopy! !

!MaSerializedGraphBuffer methodsFor: 'private accessing' stamp: 'cmm 7/16/2002 21:42'!
headerSize

	^self class headerSize
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: 'cmm 3/7/2005 14:37'!
increaseBufferSizeBy: anInteger

	anInteger < self headerSize
		ifTrue:
			[ MaObjectSerializationSoftwareError signal: 'This object being appended is not properly supported.' ].
	self bufferSize: self bufferSize + anInteger
! !

!MaSerializedGraphBuffer methodsFor: 'debugging' stamp: 'cmm 2/7/2005 17:29'!
isWhole
	"Answer whether I have all the object buffers needed to reconstitute my entire graph."

	^ self buffersMissingFromWhole isEmpty! !

!MaSerializedGraphBuffer methodsFor: 'private creation' stamp: 'cmm 10/21/2004 12:52'!
newPremadeBuffers

	^MaObjectBuffer bufferClasses collect: [ :each | each new ]
! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 2/15/2005 22:18'!
objectCount

	| count |
	count _ 0.
	self buffersDo: [ : each | count _ count + 1 ].
	^ count! !

!MaSerializedGraphBuffer methodsFor: 'private creation' stamp: 'cmm 3/24/2005 12:50'!
postCopy

	byteArray _ byteArray copy! !

!MaSerializedGraphBuffer methodsFor: 'printing' stamp: 'cmm 4/3/2003 00:11'!
printOn: aStream

	| buffers |

	super printOn: aStream.
	byteArray notNil
		ifTrue:
			[ buffers _ self buffers.
			aStream
				nextPutAll: ' (';
				maPrint: buffers size;
				nextPutAll: ' objects in ';
				maPrint: self bufferSize;
				nextPutAll: ' bytes)'.
			buffers notEmpty
				ifTrue:
					[ aStream tab.
					buffers first maPrintAbbreviatedOn: aStream ] ]
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: ''!
resetBufferSize
	"Reset the current pointer (which is the bufferSize) back to the beginning."

	self bufferSize: self headerSize
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: ''!
resetByteArray: aByteArray

	self
		byteArray: aByteArray;
		resetBufferSize
! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 4/3/2003 00:11'!
trimmedByteArray

	^byteArray
		copyFrom: 1
		to: self bufferSize! !

MaUserError subclass: #MaObjectSerializationUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

PackageInfo subclass: #MaObjectSerializationPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-Info'!

!MaObjectSerializationPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 1/29/2003 23:37'!
prerequisitePackages

	^#('Ma proxy support' 'Ma special collections' 'Ma traverse object graphs')! !

!MaObjectSerializationPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2003 00:41'!
readmeText

	^'I am a general object serialization and materialization framework.  Currently, I convert objects to ByteArrays and back.  I am used by both the "Ma client server" and "Magma" packages.  I offer a lot of flexibility in the way objects are serialized and materialized, even to the way the object graphs are traversed during serialization (courtesy of "Ma object serialization").

The major class is MaObjectSerializer, see it for more information.  It utilizes a MaDefaultOidManager, a MaDefaultClassIdManager, and a MaObjectGraphTraversalStrategy to create a MaSerializedGraphBuffer, the final object that wraps the ByteArray.'! !

!True methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForTrue
! !

!BlockContext class methodsFor: '*ma object serialization' stamp: 'cmm 11/15/2004 15:21'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ (aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray) asBlockContext! !

!BlockContext methodsFor: '*ma object serialization' stamp: 'cmm 11/10/2004 12:01'!
maAsStorageObject

	^ MaBlockContextStorage newFor: self! !

!StrikeFont class methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:11'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"Materialize the DiskProxy which computes a reference to an appropriate StrikeFont in this materializing system."

	| diskProxy |
	diskProxy _ aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!StrikeFont methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:10'!
maAsStorageObject 

	^ DiskProxy
		global: #StrikeFont selector: #familyName:size:emphasized:
		args: { self familyName.  self height.  self emphasis }! !

!StrikeFont methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:05'!
maUsesStandardStorage 

	^ false! !

!BasicClassOrganizer class methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:20'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This method exists to mirror the logic in my instance-side #objectForDataStream:, whereby if the organizer being stored has a normal Class subect, a DiskProxy is stored instead.  For Ma object serialization, this was done on my instance-side in #maAsStorageObject.  If I was not stored as the DiskProxy, then I would not get to this method."

	| diskProxy |
	diskProxy _ aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!BasicClassOrganizer methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:19'!
maAsStorageObject 

	^ self maUsesStandardStorage
		ifTrue: [ super maAsStorageObject ]
		ifFalse: [ DiskProxy global: self subject name selector: #organization args: #() ]! !

!BasicClassOrganizer methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:17'!
maUsesStandardStorage 

	^ (self hasSubject and: [ self subject isKindOf: Class ]) not! !

!FlapTab class methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 12:50'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This method exists to mirror the logic in my instance-side #objectForDataStream, whereby if the FlapTab being stored is a global flap (i.e., present in all Projects), a DiskProxy is stored instead.  For Ma object serialization, this was done on my instance-side in #maAsStorageObject.  If I was not stored as the DiskProxy, then I would not get to this method."

	| diskProxy |
	diskProxy _ aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!FlapTab methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 12:47'!
maAsStorageObject
	"Emulating the behavior of #objectForDataStream:."
	^ self isGlobalFlap
		ifTrue:
			[ DiskProxy
				global: #Flaps selector: #globalFlapTabOrDummy: 
				args: {self flapID} ]
		ifFalse: [ self ]! !

!FlapTab methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 12:47'!
maUsesStandardStorage
	^ self isGlobalFlap not! !

!SmallInteger class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!SmallInteger class methodsFor: '*ma object serialization' stamp: 'cmm 6/2/2004 16:54'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^MaOidCalculator
		objectWithOid: aMaByteObjectBuffer oid
		ifNone: [ self error: aMaByteObjectBuffer , ' is not a buffer for a SmallInteger.' ]
! !

!IdentityBag methodsFor: '*ma object serialization' stamp: 'cmm 6/28/2004 23:20'!
maIsEqualityHashedCollection

	^ false! !

!False methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForFalse
! !

!WeakIdentityKeyDictionary methodsFor: '*ma object serialization' stamp: 'cmm 6/28/2004 23:22'!
maIsEqualityHashedCollection

	^ false! !

!MaWeakIdentityKeyDictionary methodsFor: '*ma object serialization' stamp: 'cmm 6/28/2004 23:21'!
maIsEqualityHashedCollection

	^ false! !

!ProtoObject class methodsFor: '*ma object serialization' stamp: 'cmm 1/17/2005 12:29'!
maIsLogicallyVariable
	"Answer whether, for ma serialization purposes, I am stored as a fixed or variable object."
	^ self isVariable! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 13:39'!
maAsStorageObject
	"Some objects should be converted to another object before being stored
	in a buffer."

	^self
! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 14:26'!
maBufferInstSize
	"Answer the number of pointers to other objects I logically have (which can be fewer than the number of physical pointers due to implementation of extra growth-space)."
	^ self maInstSize! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 14:28'!
maIsHashedCollection

	^false
! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 2/13/2005 21:52'!
maIsTransient: varIndex
	"Answers whether my object referenced at varIndex should be serialized."
	
	varIndex = 0 "root object" ifTrue: [ ^ false ].
	self maTransientVariables isEmpty ifTrue: [ ^ false ].
	varIndex > self class instSize ifTrue: [ ^ false ].
	^ self maTransientVariables includes: (self class maAllInstVarNamesAt: varIndex)! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/17/2005 10:36'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	| cl |
	cl _ self class.
	cl isBytes ifTrue: [ ^ aMaObjectSerializer preMadeByteObjectBuffer ].
	(self maIsForwardingProxy not and: [ self isBehavior ]) ifTrue: [ ^ aMaObjectSerializer preMadeClassObjectBuffer ].
	(cl isWords and: [ cl isPointers not ]) ifTrue: [ ^ aMaObjectSerializer preMadeVariableWordBuffer ].
	cl maIsLogicallyVariable ifTrue: [ ^ aMaObjectSerializer preMadeVariableObjectBuffer ].
	^ aMaObjectSerializer preMadeFixedObjectBuffer! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 17:57'!
maSerializationClass
	"All objects that can be serialized by Ma object serialization have their classes recorded mapped to an id except for Classes instances.  The class for these objects maps directly to Metaclass, rather than their specific metaclass instance."

	^ self class! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 17:58'!
maShouldAppendWithPath: path parent: parent index: indexInteger
	^ parent isNil
	or:
		[ self maRequiresOwnBuffer
		and: [ (parent maIsTransient: indexInteger) not ] ]! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 17:59'!
maShouldTraverseWithPath: path parent: parent index: indexInteger
	| cl |
	cl _ self class.
	cl isBytes ifTrue: [ ^ false ].
	(cl isVariable and: [ cl isPointers not ]) ifTrue: [ ^ false ].
	^ self maUsesStandardStorage
	and: [ (parent maIsTransient: indexInteger) not ]! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 14:27'!
maSizeIn: aMaObjectBuffer
	"Answer the size of the buffer that contains the object references, excluding the header."

	^ self maBufferInstSize * aMaObjectBuffer slotSize! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 18:00'!
maTransientVariables
	^ #()! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 17:30'!
maUsesStandardStorage
	"Override this method to store a different externalized version of me."

	^ true! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 18:04'!
maWantsPostMaterialization
	"Most objects do not need any preserialization behavior, therefore this allows the serializer to avoid the overhead of withAllSuperclassesDo:."
	^ false! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 18:04'!
maWantsPreSerialization
	"Most objects do not need any preserialization behavior, therefore this allows the serializer to avoid the overhead of withAllSuperclassesDo:."
	^ false! !

!EToyProjectHistoryMorph class methodsFor: '*ma object serialization' stamp: 'cmm 2/17/2005 13:59'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"It seems these ProjectHistoryMorphs are simply image-specific things, i.e., the history of whatever projects in the current image."

	^ self new! !

!EToyProjectHistoryMorph methodsFor: '*ma object serialization' stamp: 'cmm 2/17/2005 13:55'!
maAsStorageObject 
	^ String maEmpty! !

!EToyProjectHistoryMorph methodsFor: '*ma object serialization' stamp: 'cmm 2/17/2005 13:55'!
maUsesStandardStorage

	^ false! !

!Character class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!Character methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForCharacter: self
! !

!ProcessorScheduler class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:37'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ Processor! !

!ProcessorScheduler methodsFor: '*ma object serialization' stamp: 'cmm 12/19/2002 23:13'!
maAsStorageObject
	"We don't even need to store the name of the global.  It's class
	gives it away."

	^String maEmpty
! !

!ProcessorScheduler methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!EventSensor class methodsFor: '*ma object serialization' stamp: 'cmm 2/6/2005 17:30'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"If I was the Sensor global, then I was stored as an empty String in a MaByteObjectBuffer and, thus, got to this method.  Otherwise, we materialize standard through the fixed-buffer."

	^ Sensor! !

!EventSensor methodsFor: '*ma object serialization' stamp: 'cmm 2/6/2005 17:21'!
maAsStorageObject 

	^ self == Sensor
		ifTrue: [ String maEmpty ]
		ifFalse: [ self ]! !

!EventSensor methodsFor: '*ma object serialization' stamp: 'cmm 2/6/2005 16:57'!
maUsesStandardStorage

	^ self ~~ Sensor! !

!EToyVocabulary class methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 21:55'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	| vocabOrDiskProxy |
	vocabOrDiskProxy _ aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray.
	^ vocabOrDiskProxy maIsDiskProxy
		ifTrue: [ vocabOrDiskProxy comeFullyUpOnReload: nil ]
		ifFalse: [ vocabOrDiskProxy ]! !

!EToyVocabulary methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 21:49'!
maAsStorageObject
	"copied from #objectForDataStream:"

	vocabularyName == #eToy ifFalse: [^ self].

	^ DiskProxy 
		global: #Vocabulary
		selector: #vocabularyNamed: 
		args: (Array with: vocabularyName)
! !

!EToyVocabulary methodsFor: '*ma object serialization' stamp: 'cmm 2/8/2005 16:36'!
maUsesStandardStorage
	^ vocabularyName == #eToy! !

!Integer methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForInteger: self
! !

!MethodContext class methodsFor: '*ma object serialization' stamp: 'cmm 11/15/2004 15:21'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ (aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray) asMethodContext! !

!MethodContext methodsFor: '*ma object serialization' stamp: 'cmm 11/10/2004 12:02'!
maAsStorageObject

	^ MaMethodContextStorage newFor: self! !

!Array class methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 23:55'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This method exists to mirror the logic in Array>>#objectForDataStream, whereby if the Array being stored is one of two special global Array's, a DiskProxy is stored instead.  For Ma object serialization, this was done on my instance-side in #maAsStorageObject.  If I was not stored as the DiskProxy, then I would not get to this method."

	| diskProxy |
	diskProxy _ aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!Array methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 23:27'!
maAsStorageObject
	"I am about to be written on an object file.  If I am one of two shared global arrays, write a proxy instead."

	"Note this behavior copied from Array>>#objectForDataStream:."
	self == (TextConstants at: #DefaultTabsArray)
		ifTrue: [ ^ DiskProxy global: #TextConstants selector: #at: args: #(DefaultTabsArray) ].
	self == (TextConstants at: #DefaultMarginTabsArray)
		ifTrue: [ ^ DiskProxy global: #TextConstants selector: #at: args: #(DefaultMarginTabsArray) ].
	^ super maAsStorageObject! !

!Array methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:06'!
maUsesStandardStorage

	^ ({ TextConstants at: #DefaultMarginTabsArray. 
	TextConstants at: #DefaultTabsArray } includes: self) not! !

!Association class methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:14'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This method exists to mirror the logic in Association>>#objectForDataStream, whereby if the Array being stored is a Smalltalk global, a DiskProxy is stored instead.  For Ma object serialization, this was done on my instance-side in #maAsStorageObject.  If I was not stored as the DiskProxy, then I would not get to this method."

	| diskProxy |
	diskProxy _ aMaObjectSerializer copyWithNewOidSpace materializeGraph: aMaByteObjectBuffer asByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!Association methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:13'!
maAsStorageObject
	"I am about to be serialized into a ByteArray.  If I am a known global, write a proxy that will hook up with the same resource in the destination system.  This behavior emulates what Association>>#objectForDataStream: does."

	^ self maUsesStandardStorage 
		ifTrue: [ self ]
		ifFalse:
			[ DiskProxy
				global: #Smalltalk selector: #associationOrUndeclaredAt: 
				args: (Array with: key) ]! !

!Association methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:10'!
maUsesStandardStorage

	^ (Smalltalk associationAt: key ifAbsent: [nil]) ~~ self! !

!Set class methodsFor: '*ma object serialization' stamp: 'cmm 11/22/2004 16:08'!
maIsLogicallyVariable
	"Answer whether, for ma serialization purposes, I am stored as a fixed or variable object."
	^ true! !

!Set class methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 12:35'!
maLoadVariableObjectFrom: aMaVariableObjectBuffer

	| skeleton |
	skeleton _ self new: aMaVariableObjectBuffer objectInstSize.
	1
		to: aMaVariableObjectBuffer objectInstSize
		do: [ :index | skeleton add: (aMaVariableObjectBuffer maInstVarAt: index) ].
	^ skeleton! !

!Set methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:55'!
maBufferInstSize

	^ self size! !

!Set methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 10:26'!
maEstablishPointerReferencesUsing: aMaObjectSerializer
	"I am currently loaded with oids of the objects that I should be referencing.  Now that objects for these oids are, themselves, materialized, I can now replace my referernces to oids wtih references to the real objects."
	| fullOfOidsCopy |
	self isEmpty ifTrue: [ ^ self ]. "performance, avoid the copy if possible.."
	fullOfOidsCopy _ self copy.
	self maRemoveAll.
	fullOfOidsCopy do:
		[ :each |
		self
			add: (
				aMaObjectSerializer
					objectWithOid: each
					ifAbsent: [ aMaObjectSerializer proxyFor: each ]) ]! !

!Set methodsFor: '*ma object serialization' stamp: ''!
maIsHashedCollection

	^true
! !

!Set methodsFor: '*ma object serialization' stamp: 'cmm 11/28/2004 16:21'!
maStreamVariablyInto: aMaVariableBuffer for: aMaObjectSerializer
	"Put the receivers instance variables into aMaVariableObjectBuffer as they fit."

	| index |
	index _ 1.
	self do:
		[ : eachLinkedObject |
		aMaVariableBuffer
			maInstVarAt: index
			put:
				(aMaVariableBuffer 
					numberToStoreFor: eachLinkedObject
					using: aMaObjectSerializer).
		index _ index + 1 ].
	3 "skip array and tally, they're taken care of logically, above."
		to: self maInstSize
		do:
			[ : namedIndex |
			aMaVariableBuffer
				maInstVarAt: index + namedIndex
				put: (aMaObjectSerializer oidFor: (self instVarAt: namedIndex)) ]! !
MaObjectBuffer initialize!
